/*start==============================================================================================================================================================================================
   Automatische Steuerung zum Maischen

   Überarbeitung "Bitter" (Lothar) und Borsti84 (Sebastian)

   V4-00FR - Relaisversion und Funkversion für den Arduino-Mega

   Updates:



   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   Die Software wird unter der MIT - Lizenz veröffentlicht

   Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files ,
   to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

   Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der zugehörigen Dokumentationen erhält, die Erlaubnis erteilt,
   sie uneingeschränkt zu benutzen, inklusive und ohne Ausnahme dem Recht, sie zu verwenden, kopieren, ändern, fusionieren, verlegen, verbreiten, unterlizenzieren
   und/oder zu verkaufen, und Personen, die diese Software erhalten, diese Rechte zu geben, unter den folgenden Bedingungen:
   Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien oder Teilkopien der Software beizulegen.
   DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER
   EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT. IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN
   SCHADEN ODER SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER
   SOFTWARE ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.
   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

  Über diese Version

    Alle Einstellungen sind mit dem Encoder vorzunehmen.
      - Encoder drehen = Werteverstellung
      - Encoder schnell drehen = schnelle Werteverstellung
      - kurz Drücken = Eingabebestätigung
      - Doppelclick innerhalb von 0,6 s = Setupmenue -> Zurück -> lfd. Programm
        So kann z.B. während des Maischens im Setup-Menü der Gradientenfaktor geändert werden. Während der Zeit im Setup-Menü stoppt der Zeitablauf nicht!
      - lang Drücken (> 4 Sekunden) = Abbruch und zurück zum Startmenü
      - bei Abbruch werden alle eingegebenen Werte beibehalten
        Wenn man z.B. einen Fehler bei der Eingabe macht, einfach lange drücken bis zum Abbruch. Dann die Eingaben durch drücken und drehen ggf. verändern.
      - während des automatischen Ablaufs sind durch Drehen des Encoders Änderungen an der Temperatur bzw. des Zeitablaufes möglich.
      - Kühlmodus: Wenn Sicherung gegen Stromausfall dann: Kühlmodus aufrufen -> Temperatur eingeben -> durch langes drücken Modus verlassen!
        In der unteren Zeile erscheint "NOT-EIN". Dann den Kühlmodus wieder aufrufen. Nach einem Stromausfall wird nun automatisch der Kühlmodus mit der zuletzt
        eingestellten Temperatur aufgerufen. Wenn der Modus nun beendet wird, erscheint in der unteren Zeile "NOT-AUS".


    Regler
    Die Steuerung der Heizung erfolgt über eine Gradientenregelung. Die Steigungsgeschwindigkeit des Temperaturanstiegs dT/dt bestimmt die Ein- und Ausschaltzeitpunkte. Sinnvoll für
    Einkocher ist hier ein Gradientenfaktor von "1".

    Sensorfehler
    Anzeige -127  => VCC (Versorgungsspannung des Sensors fehlt
    Anzeige 85.00   => Byte interner Sensorfehler ggf. Leitung zu lang
    Anzeige 0.00  => Datenleitung oder GND fehlt


    Schaltvorgänge des Ein- und Ausschalten sind immer nach einer einstellbaren Wartezeit möglich. Die Wartezeit für SSR auf "0" gesetzt werden.Dadurch soll stetiges Schalten verhindert werden.

    Die Kühlfunktion verwendet auch den Gradientenregler, jedoch kommt hier noch die Einschaltverzögerung für den Kompressor hinzu. Wird die eingestellte Tempertur erreicht und der Kompressor ausschaltet, dann
    dauert es mindestens die eingestelle Zeit bis der Kompressor wieder einschaltet (für einen Kühlschrank etwa 5 min. und für Peltier-Elemente 0 min.)
    Der Rührer kann auf Dauerbetrieb oder Intervallbetrieb eingestellt werden.Die Einschalt- und Ausschaltsequenzen sind einstellbar.
    Das Kochen des Suds kann erst nach einer vorgegebenen Temperaturschwelle erfolgen (Vorgabe 98°C). Dies soll das Überkochen verhinden. Erst danach kann die Zeitzählung aktiviert werden.
    Es können max. 6 Hopfengaben festgelegt werden. Erinnert wird durch den Brauerruf.


    Die Funktionen die auf den Vergleich Sollwert mit Istwert
    beruhen werden immer erst nach 10 Messungen ausgeführt.

    Anschlüsse:
    PIN 2 : Encoder => Pullup geschaltet => Encoderzuleitung mit GND versorgen
    PIN 3 : Encoder => Pullup geschaltet => Encoderzuleitung mit GND versorgen
    PIN 4 : Taster von Encoder => Pullup geschaltet => Zuleitung mit GND versorgen
    PIN 5 : DS1820 ONE_WIRE_BUS Sensor => 4,7k zw. 5V und PIN5
    PIN 6 : Reset ESP8266-01
    PIN 7 : Heizung Nullleiter
    PIN 8 : Heizung Phase
    PIN 9 : Geschwindigkeitsumschaltung
    PIN 10: Ruf (Summer)
    PIN 11: Rührwerk Nullleiter
    PIN 12: Rührwerk Phase
    PIN 18 : Funkempfänger (INT 3)
    PIN 19 : Funksender
    PIN 20: Anschluss SDA vom Display
    PIN 21: Anschluss SCL vom Display

    PIN A0: Pumpensensor
    PIN A3: Pumpenrelais
*/

#define ONE_WIRE_BUS 5

//Für die Ansteuerung von Heizung und Rührwerk sind jeweils 2 Realis für eine allpolige
//Ansteuerung vorgesehen. Natürlich kann man jeweils auch nur ein Relais zum Schalten verwenden.

//Ausgänge an DigitalPIN ----------------------------------------------------
#define HeizungR1  8                                    //Zuordnung Heizung Phase Relais1
#define HeizungR2  7                                    //Zuordnung Heizung Nullleiter Relais2
#define Speedrelais 9                                   //Geschwindigkeitsumschaltung
#define RufR  10                                        //Zuordnung Braumeisterruf
#define RuehrerR2   11                                  //Zuordnung Rührwerk Nullleiter Relais 2
#define RuehrerR1   12                                  //Zuordnung Rührwerk Phase Relais 1

//Ausgänge am AnalogPIN------------------------------------------------------
#define fuellstand_sensor A0                            //Steuerung der Würzepumpe
#define fuellstand_pumpe A1
//---------------------------------------------------------------------------


//ESP8266 -------------------------------------------------------------------
#define reset8266   6                                   //Resetpin 8266

//433MHz Sender/Empfänger----------------------------------------------------
#define sender 19                                       //Sender an Anschluss 19
#define empfaenger_int 5                                //477 MHz Empfänger an Interrupt 5 (Pin #18)
//---------------------------------------------------------------------------

/*

    Speicheraufteilung EEPROM ----------------------------------------------
*/
#define notfallmodus 0              //Byte - Flag für Notfallmodus Maischen/Kochen
#define rastnr 1                    //Byte - Letzte Rast vor Stromausfall
#define rasttemp_aktuell 2          //Byte - aktuelle Rasttemperatur vor Stromausfall
#define rastzeit_aktuell 3          //Byte - aktuelle Rastzeit vor Stromausfall
#define rastzeit_1 4                //Byte - Speicher für eingestellte Rastzeitwerte
#define rasttemp_1 5                //Byte - Speicher für eingestellte Rasttemperaturen
#define rastzeit_2 6                //Byte
#define rasttemp_2 7                //Byte
#define rastzeit_3 8                //Byte
#define rasttemp_3 9                //Byte
#define rastzeit_4 10               //Byte
#define rasttemp_4 11               //Byte
#define rastzeit_5 12               //Byte
#define rasttemp_5 13               //Byte
#define rastzeit_6 14               //Byte
#define rasttemp_6 15               //Byte
#define MaischTemp 16               //Byte
#define zeit_h 17                   //Byte - gespeicherte Zeit h,m,s
#define zeit_m 18                   //Byte
#define zeit_s 19                   //Byte
#define Rasten 20                   //Byte
#define rastmodus 21                //Integer - als long gespeichert - 4 Byte Platz lassen
#define notfall 25                  //Byte - Setupvariable
#define rdauer 26                   //Byte - Rastdauer
#define ruehrer_ie 27               //Byte - Rührer Intervall EIN
#define ruehrer_ia 28               //Byte - Rührer Intervall AUS
#define Kochschwelle 29             //Byte
#define logging 30                  //Byte - Setupvariable Logging EIN/AUS
#define kuehlverz 31                //Integer - als long gespeichert - 4 Byte Platz lassn - Einschaltverzögerung Kühlen
#define wein_h 35                   //Integer - als long gespeichert - 4 Byte Platz lassen - Einschaltverzögerung Heizen
#define graf_h 39                   //Integer - als long gespeichert - 4 Byte Platz lassen - Gradientenfaktor Heizen
#define graf_k 43                   //Integer - als long gespeichert - 4 Byte Platz lassen - Gradientenfaktor Kühlen
#define k_aktiv 47                  //Byte - Kühlen im Notfallmodus
#define g_kuehltemp 48              //Byte - zuletzt eingestellte Kühltemperatur
#define hopfengabe1 49              //Byte - Hopfengaben Notfallspeicher
#define hopfengabe2 50              //Byte
#define hopfengabe3 51              //Byte
#define hopfengabe4 52              //Byte
#define hopfengabe5 53              //Byte
#define hopfengabe6 54              //Byte
#define Kochzeit 55                 //Byte - Kochzeit Notfallspeicher
#define Wlan 56                     //Byte - WLAN Ein/Aus
#define Heizung_EIN 57              //LongInt Speicheradressen Steckdosencode
#define Heizung_AUS 61              //LongInt Speicheradressen Steckdosencode
#define Ruehrer_EIN 65              //LongInt Speicheradressen Steckdosencode
#define Ruehrer_AUS 69              //LongInt Speicheradressen Steckdosencode
#define Ruf_EIN  73                 //LongInt Speicheradressen Steckdosencode
#define Ruf_AUS 77                  //LongInt Speicheradressen Steckdosencode
#define isozeit_h 81                //Byte Stundenwert Nachisomerisierung
#define isozeit_m 82                //Byte Minutenwert Nachisomerisierung
#define isozeit_s 83                //Byte Sekundenwert Nachisomerisierung
#define niso 84                     //Byte Dauer Nachisomerisierung
#define loggerwahl 85               //BYTE Loggerprogramm auswählen
#define umwaelzwahl 86              //BYTE Rührwerk oder Malzrohrpumpe ?

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*Relaislogik festlegen
   ACHTUNG!!!!!!!
   bei Verwendung der China Relais-Platinen muss die Logik immer "AUS = HIGH" sein. Alle Geräte müssen dann am Schließer der
   Relais angeschlossen werden! Ansonsten liegt im ausgeschalteten Zustand Spannung am Ausgang!
*/

//Heizungsrelais +++++++++++++++++++
//
//Ist H_AUS als HIGH definiert, dann schaltet das Relais die Heizung im ANGEZOGENEN ZUSTAND AUS (Historische Voreinstellung für Relaisplatinen
//Ist H_EIN als HIGH definiert, dann schaltet das Relais die Heizung im ANGEZOGENEN ZUSTAND EIN
//Ist R_AUS als HIGH definiert, dann schaltet das Relais den Rührer im ANGEZOGENEN ZUSTAND AUS
//Ist R_EIN als HIGH definiert, dann schaltet das Relais den Rührer im ANGEZOGENEN ZUSTAND EIN
//
//Die gewünschte Logik auskommentieren und die jeweils andere einkommentieren

//#define H_AUS HIGH
//#define H_EIN LOW

//Relaislogik umkehren

#define H_AUS LOW
#define H_EIN HIGH

//Rührerrelais +++++++++++++++++++

#define R_AUS LOW
#define R_EIN HIGH

//Relaislogik umkehren

// #define R_AUS HIGH
// #define R_EIN LOW

//Rufrelais +++++++++++++++++++

#define B_AUS LOW
#define B_EIN HIGH

//Relaislogik umkehren

// #define B_AUS HIGH
// #define B_EIN LOW

//Sudpumpe, nicht Malzrohrpumpe+++++++++++++++++++

#define SUDPUMPE_AUS LOW
#define SUDPUMPE_EIN HIGH

//Relaislogik umkehren z.B. für Chinarelais

//#define SUDPUMPE_AUS HIGH
//#define SUDPUMPE_EIN LOW

//welches Signal vom Schwimmschalter? Folgende Zuordnung wenn der Schwimmschalter
//schliesst

#define Sensor_AUS 1
#define Sensor_EIN 0

//Folgende Zuordnung wenn der Schwimmschalter öffnet

//#define Sensor_AUS 0
//#define Sensor_EIN 1



//---------------------------------------------------------------------------

//Speichervariable Steckdosencode -------------------------------------------

unsigned long funk_heizung_ein;
unsigned long funk_heizung_aus;

unsigned long funk_ruehrer_ein;
unsigned long funk_ruehrer_aus;

//Brauerruf auf die Funksteckdose!
unsigned long funk_ruf_ein;
unsigned long funk_ruf_aus;

bool eingeschaltet = false;

byte adr = 1;  //Adresse im EPROM

#define RESEND_SNIFFED_VALUES 10             //jeden Funkbefehl 10 mal wiederholen
unsigned long value;

unsigned long heizungInterval1 = 0;             //alle 5 sec. den Zustand der Funksteckdosen überprüfen
unsigned long heizungInterval2 = 0;

//---------------------------------------------------------------------------


//LCD Initialisierung -------------------------------------------------------

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address

//---------------------------------------------------------------------------

//433 MHz Funksender---------------------------------------------------------
#include <RCSwitch.h>
RCSwitch mySwitch = RCSwitch();

//Click Encoder--------------------------------------------------------------

#include <ClickEncoder.h>
#include <TimerOne.h>


//Encoder Initialisierung ---------------------------------------------------

//Encoder drehen
#define pinA 2  //können auch beliebige andere Anschlüsse sein!
#define pinB 3  //tauschen der Werte der Drehumkehr

//#define ENC_DECODER (1 << 2)   //auskommentieren, wenn Probleme mit Encoder

//#define ENC_HALFSTEP 1     //auskommentieren, wenn Probleme mit Encoder

#define stepsPerNotch 4 // Klicks bis zum nächsten Schritt

// Taster drücken
#define taster 4     // Taster am Pin 4 für Bestätigung und Abbruch

ClickEncoder *encoder;

void timerIsr() {
  encoder->service();
}

int last;
int wert;
bool ButtonPressed = false;
byte drehen = 0;            //Drehgeber Werte
//---------------------------------------------------------------------------


//Temperatursensor DS1820 Initialisierung -----------------------------------
#include <OneWire.h>
#include <DallasTemperature.h>

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);

// arrays to hold device address
DeviceAddress insideThermometer;
//---------------------------------------------------------------------------

//Zeitmessung----------------------------------------------------------------
//Bibliothek ist alternativ
//#include <Time.h>
#include <TimeLib.h>
//---------------------------------------------------------------------------

//EEPROM für Voreinstellungen------------------------------------------------
#include <EEPROM.h>
//---------------------------------------------------------------------------

// Messergebnisse -----------------------------------------------------------
byte val = 0;        // Variable um Messergebnis zu speichern
//---------------------------------------------------------------------------


//Allgemein Initialisierung--------------------------------------------------
byte anfang = 0;                    //Start des jeweiligen Modus
float altsekunden;                  //Hilfsvariable Zeitmessung
byte regelung = 0;                  //Regelung aktiv/inaktiv
byte heizung = 0;                   //Heizung EIN/AUS
byte sensorfehler = 0;              //Temperaturfühler defekt oder fehlt

boolean sollwerterreicht = false;   //eingestellte Temperatur erreicht/nicht erreicht
long kwarten = 0;                   //Wartezeit kühlen
float sensorwert;                   //eingelesener Istwert
float isttemp = 20;                 //Vorgabe 20 damit Sensorfehler am Anfang nicht anspricht
int modus = 0;                      //Programmmodus - 0=Hauptmenü
int rufmodus = 0;                   //merkt sich den Modus nach Brauerruf
float rufsignalzeit = 0;            //so lange dauert der Ruf - wird im Programm gesetzt
boolean nachgussruf = false;        //Signal wenn Nachgusstemp erreicht
byte x = 1;                         //aktuelle Rast Nummer
byte altx;                          //Merker für letzte Rast
byte h = 0;                         //aktuelle Hopfengabe
byte y = 1;                         //Übergabewert von x für Braumeisterruf
byte n = 0;                         //Counter Messungserhöhung zur Fehlervermeidung
byte pause = 0;                     //Counter für Ruftonanzahl

byte sekunden = 0;                  //Zeitzählung
byte minuten = 0;                   //Zeitzählung
byte minutenwert = 0;               //Zeitzählung
byte stunden = 0;                   //Zeitzählung

byte blinker;                       //Hilfsvariable blinken;
byte abbruchkochen;                 //Zeitzählung bis Kochabbruch


//Vorgabewerte zur ersten Einstellung-------------------------------------------
byte sollwert = 20;                 //Sollwertvorgabe für Anzeige
byte maischtemp = 45;               //Vorgabe Einmasichtemperatur
byte rasten = 3;                    //Vorgabe Anzahl Rasten
byte rastTemp[] = {
  0, 55, 64, 72, 72, 72
};                                  //Rasttemperatur Werte
byte rastZeit[] = {
  0, 15, 40, 25, 20, 20
};                                  //Rastzeit Werte
byte braumeister[] = {
  0, 0, 0, 0, 0, 0
};                                  //Braumeisterruf Standard ist AUS
byte endtemp = 78;                  //Vorgabewert Endtemperatur
byte kochzeit = 90;


/* Hopfengaben----------------------------------------------------------------
  "maxrasten" kann geändert werden. die Vorgabewerte in den Klammern müssen nicht, können
  aber angepasst werden. "hanz" ist die Voreinstellung für die Auswahl der Rastanzahl.
*/

byte const maxgaben = 6;
byte hopfengabe[maxgaben] = {0, 0, 0, 0, 0, 0}; //Zeiten für die Hopfengaben 90 min. können vorgegeben werden
//byte hopfengabe[maxgaben] = (90,20,10,0,0,0];
byte hanz = 3;                      //Vorgabewert Anzahl Hopfengaben

//----------------------------------------------------------------------------
byte nachisomerisierung = 20;  //Vorgabe 20 min. Wartezeit
byte isoTemperatur = 80; //Temperaturgrenze für Nachisomerisierung
byte nachiso_h;     //Hilfsvariable zur Zeitsetzung nach Stromausfall
byte nachiso_m;
byte nachiso_s;
//----------------------------------------------------------------------------

// Erweiterung Rührwerk-------------------------------------------------------

char ja_nein[2] = {'N', 'J'};     //Antworten Dauerbetrieb Ja/nein
byte intervalEin = 60;            //Voreinstellung 60s EIN wenn noch kein Wert im EEPROM
byte intervalAus = 60;            //dann 60s AUS
char dauerbetrieb = 'N';          //Voreinstellung Intervallbetrieb
byte altdrehen;                   //alten Wert des Drehencoders merken
byte tempdrehen;                  //Merker für aktuellen Wert von "drehen" (für Doppelclick)
bool firstinterval = true;        //das erste Rührerintervall startet direkt nach Ende "Heizen"
long intervalstart;               //Intervallzyklus startet
byte rwerk = 0;                   //Hilfsvariable für Rührwekssteuerung (speichert den alten Zustand)
bool ruehrer = true;
bool pumpe = false;
byte umwaelzen;
bool geschwindigkeitsrelais = true;
bool highspeed = false;
#define LOW_SPEED 0
#define HIGH_SPEED 1

//Kochen---------------------------------------------------------------------
bool schwelle_erreicht = false;   //Kochschwelle erreicht, danach Wartezeit bis Abbruch

byte kschwelle = 98;              //Voreinstellung - ab hier ertönt der Brauerruf


unsigned long kzeitverz = 0;      //Wartezeit Einschalten Kompressor NICHT ÄNDERN
long esvheizen = 0;               //Einschaltverzögerung für Zündung - wird noch initialisiert
long esvpumpen = 30000;           //30s Einschaltverzögerung Pumpe
bool first = true;                //erster Anlauf ohne Zeitverzögerung
bool dclick;                      //Doppelclick gedrückt ?

long hwarten =  0;                //Wartezeitmessung Start

//Steigungsberechnung K/m -> Kelvin/Minute - Hinweis auf die Aufheizrate des Kessels

float alte_zeit;                  //Zeit bei t-1
float alte_temperatur;            //Temperatur bei t-1
unsigned long messzyklus = 10000; // Zeit im ms für dT und dt Vorgabe 10s.

float gradient;                   // Steigungswert
float kh = 1;                     //Gradientenfaktor kh (Heizen) - Vorgabe 1
float kk = 10;                    //Gradientenfaktor kk (Kühlen) - Vorgabe 10

//Logging -----------------------------------------------------------------------------

bool loggen = false;              //Daten Soll/Ist an Logprogramm übertragen zunächst deaktiviert
byte logwahl = 2;                 //Voreinstellung AiO
byte logprog = 0;                 //Auswahl des Logprogramms
bool aio = true;
bool serialcom = false;
bool logview = false;


byte altmodus;                    //merkt sich den Modus für Doppelclick
byte zeitz = true;                //Zeitzählung nach Doppelclick nicht stoppen (zeitz = false)


//Notfallmodus nach Stromausfall ------------------------------------------------------
//Speichert den Zustand in Modus 28,29,30

byte Notfallmodus;                //Notfallmodus Maischeprogramm aktiv (es gab einen Stromausfall)
byte RastNr;                      //gespeicherte Rastnummer
byte RastTemp;                    //gespeicherte aktuelle Rasttemperatur
byte RastZeit;                    //gespeicherte aktuelle Rastzeit
byte RastZeit_h;                  //Rastzeit Stundenanteil
byte RastZeit_m;                  //Rastzeit Minutenanteil
byte RastZeit_s;                  //Rastzeit Sekundenanteil
int RastModus;                    //gespeicherter Modus
bool zeit_setzen;                 //Hilfsvariable für Settime

bool notfall_aktiv = false;       //soll der Notfallmodus genutzt werden?

//WLAN --------------------------------------------------------------------------------
bool wlanAktiv = false;

char reply[500];
char antwort[500];
const bool printReply = true;
const char line[] = "-----\n\r";
char command[20];
char ipAddress [15];
unsigned long lan_aufruf = 30000;  //Wartezeit Webseitenaufruf

String responce; //enthält die Daten vom PC

bool uebertragungsfehler = false;


//Kühlmodus ---------------------------------------------------------------------------

bool knot;   //Kühlmodus nach Notfall gespeichert ?

//Jodprobe ----------------------------------------------------------------------------
int tz = 0;  //Anzahl Piepser für Jodprobe - Vorgabe 3 in Modus 29
bool signalende;  //nur einmal an Jodprobe erinnern

//Würzepumpe --------------------------------------------------------------------------
long int warten;
long int pwarten;
bool anzeige;


//setup================================================================================
void setup()
{
  drehen = sollwert;

  encoder = new ClickEncoder(pinB, pinA, taster, stepsPerNotch);

  Timer1.initialize(1000);
  Timer1.attachInterrupt(timerIsr);

  last = -1;

  mySwitch.enableTransmit(sender);
  mySwitch.setRepeatTransmit(RESEND_SNIFFED_VALUES);


  pinMode(HeizungR1, OUTPUT);   // DigiPin als Ausgang
  pinMode(HeizungR2, OUTPUT);
  digitalWrite(HeizungR1, H_AUS);
  digitalWrite(HeizungR2, H_AUS);

  pinMode(RuehrerR1, OUTPUT);
  pinMode(RuehrerR2, OUTPUT);
  digitalWrite(RuehrerR1, R_AUS);
  digitalWrite(RuehrerR2, R_AUS);
  mySwitch.send(funk_ruehrer_aus, 24);

  pinMode(fuellstand_sensor, INPUT);
  digitalWrite(fuellstand_sensor, HIGH);  //PullUp-Widerstand einschalten
  pinMode(fuellstand_pumpe, OUTPUT);
  digitalWrite(fuellstand_pumpe, SUDPUMPE_AUS);  //Pumpe ist ausgeschaltet


  pinMode(RufR, OUTPUT);
  digitalWrite(RufR, B_AUS);

  pinMode(Speedrelais, OUTPUT);
  digitalWrite(Speedrelais, LOW_SPEED); //Normale Geschwindigkeit als Voreinstellung
  highspeed = false;



  //Stabilisierung des Drehencoders

  digitalWrite(pinA, HIGH);  //PullUp-Widerstand einschalten
  digitalWrite(pinB, HIGH);  //PullUp-Widerstand einschalten


  //LCD Setup --------------------------------------------------------------------------
  lcd.begin(20, 4);

  lcd.setCursor(0, 0);
  lcd.print("AiO_MEGA_20x4_V4_0");

  lcd.setCursor(0, 2);
  lcd.print ("Allzeit Gut Sud");

  digitalWrite(RufR, B_EIN);   // Alarmtest
  delay(2000);
  digitalWrite(RufR, B_AUS);   // Alarm ausschalten

  //WLAN aktivieren --------------------------------------------------------------------
  wlanAktiv = false;
  if (EEPROM.read(Wlan) == 1) {
    wlanAktiv = true;
    Serial.begin(115200);
    Serial2.begin(115200);
    connectWiFi();
  }

  lcd.clear();
  // -----------------------------------------------------------------------------------


  //Temperatursensor DS1820 ------------------------------------------------------------
  sensors.getAddress(insideThermometer, 0);
  sensors.setResolution(insideThermometer, 12);
  //------------------------------------------------------------------------------------

  //Rührparameter einlesen -------------------------------------------------------------

  if (EEPROM.read(rdauer) == 0) dauerbetrieb = 'N';
  if (EEPROM.read(rdauer) == 1) dauerbetrieb = 'J';

  intervalEin = EEPROM.read(ruehrer_ie);
  intervalAus = EEPROM.read(ruehrer_ia);

  if (intervalEin == 255) (intervalEin = 60);
  if (intervalAus == 255) (intervalAus = 60);

  // Kochschwelle einlesen --------------------------------------------------------------
  kschwelle = EEPROM.read(Kochschwelle);

  if (kschwelle == 255) (kschwelle = 98);  //Vorgabe wenn noch nichts im EEPROM
  //-------------------------------------------------------------------------------------

  //Funksteckdosencode einlesen -----------------------------------------

  init_funk();


  //Wiedereinschaltverzögerung Heizungsrelais -------------------------------------------

  if (EEPROMReadlong(wein_h) > 100000) EEPROMWritelong(wein_h, 10000);
  esvheizen = EEPROMReadlong(wein_h);

  //Wiedereinschaltverzögerung Kühlung --------------------------------------------------

  if (EEPROMReadlong(kuehlverz) > 300000) EEPROMWritelong(kuehlverz, 300000);
  kzeitverz = EEPROMReadlong(kuehlverz);

  if (EEPROMReadlong(graf_h) > 100) EEPROMWritelong(graf_h, kh * 10); //Vorgabewert Gradientenfaktor für Heizen
  kh = EEPROMReadlong(graf_h) / 10;

  if (EEPROMReadlong(graf_k) > 100) EEPROMWritelong(graf_k, kk * 10); //Vorgabewert Gradientenfaktor für Heizen
  kk = EEPROMReadlong(graf_k) / 10;

  //Logging verwenden ? -----------------------------------------------------------------

  loggen = EEPROM.read(logging);
  if (loggen)
  {
    Serial.begin(115200);  // Serielle Schnittstelle für Logging
    logprog = EEPROM.read(loggerwahl);

    switch (logprog)
    {
      case 0 : {
          serialcom = true;
          logview = false;
          aio = false;
          break;
        }
      case 1 : {
          logview = true;
          serialcom = false;
          aio = false;
          break;
        }
      case 2:  {
          aio = true;
          serialcom = false;
          logview = false;
          break;
        }
    }

  }

  //Pumpe oder Rührwerk ? ------------------------------------------------------------------

  byte wahl = EEPROM.read(umwaelzwahl);
  if (wahl == 0) {
    ruehrer = true;
    pumpe = false;
  } else {
    ruehrer = false;
    pumpe = true;
  }
  //----------------------------------------------------------------------------------------

  //-------------------------------------------------------------------------------------

  //Funksteckdosen Heizung/Rührer Aus----------------------------------------------------

  mySwitch.send(funk_heizung_aus, 24);  //Schaltet die FUnksteckdose aus
  digitalWrite(HeizungR2, H_AUS);       // Heizung ausschalten
  digitalWrite(HeizungR1, H_AUS);       // Heizung ausschalten
  delay(100);
  rwerk = 1;
  ruehrerEinAus(0);                     //zunächst natürlich AUS
  rwerk = 0;
  //-------------------------------------------------------------------------------------


  if (EEPROM.read(k_aktiv) == 1) {
    modus = 1;
    knot = false;
    drehen = EEPROM.read(g_kuehltemp);
  } else knot = true; //Stromausfall im Kühlmodus ?

  //Einsprungstelle nach Stromausfall Maischen------------------------------------------

  notfall_aktiv = EEPROM.read(notfall);   //soll nach einem Stromausfall der letzte Programmpunkt aufgerufen werden?

  if (notfall_aktiv)
  {
    Notfallmodus = EEPROM.read(notfallmodus);
    if (Notfallmodus == 1)
    {
      RastNr = EEPROM.read(rastnr);
      RastTemp = EEPROM.read(rasttemp_aktuell);
      RastZeit = EEPROM.read(rastzeit_aktuell);
      RastZeit_h = EEPROM.read(zeit_h);
      RastZeit_m = EEPROM.read(zeit_m);
      RastZeit_s = EEPROM.read(zeit_s);
      maischtemp = EEPROM.read(MaischTemp);
      rastZeit[1] = EEPROM.read(rastzeit_1);
      rastTemp[1] = EEPROM.read(rasttemp_1);
      rastZeit[2] = EEPROM.read(rastzeit_2);
      rastTemp[2] = EEPROM.read(rasttemp_2);
      rastZeit[3] = EEPROM.read(rastzeit_3);
      rastTemp[3] = EEPROM.read(rasttemp_3);
      rastZeit[4] = EEPROM.read(rastzeit_4);
      rastTemp[4] = EEPROM.read(rasttemp_4);
      rastZeit[5] = EEPROM.read(rastzeit_5);
      rastTemp[5] = EEPROM.read(rasttemp_5);
      rastZeit[6] = EEPROM.read(rastzeit_6);
      rastTemp[6] = EEPROM.read(rasttemp_6);
      rastTemp[RastNr] = RastTemp;
      rastZeit[RastNr] = RastZeit;
      rasten = EEPROM.read(Rasten);
      RastModus = EEPROMReadlong(rastmodus);
      hopfengabe[0] = EEPROM.read(hopfengabe1);
      hopfengabe[1] = EEPROM.read(hopfengabe2);
      hopfengabe[2] = EEPROM.read(hopfengabe3);
      hopfengabe[3] = EEPROM.read(hopfengabe4);
      hopfengabe[4] = EEPROM.read(hopfengabe5);
      hopfengabe[5] = EEPROM.read(hopfengabe6);
      kochzeit = EEPROM.read(Kochzeit);

      modus = RastModus;
      anfang = 0;
      x = RastNr;
      rastTemp[x] = RastTemp;
      rastZeit[x] = RastZeit;
      zeit_setzen = true;
    } else zeit_setzen = false;
  }
  //für Gradientenberechnung ------------------------------------------------------------

  alte_zeit = millis(); //beim ersten Anlauf etwas warten

  alte_temperatur = 25;  // Dämpft die erste Gradientenberechnung
  //-------------------------------------------------------------------------------------

  x = 1;


}

//Ende Setup=============================================================================

//loop===================================================================================
void loop()
{
  drehen += encoder->getValue();

  if (drehen != last) {
    last = drehen;
  }

  ButtonPressed = false;
  ClickEncoder::Button b = encoder->getButton();
  if (b != ClickEncoder::Open)
  {
    switch (b)
    {
      case ClickEncoder::Pressed:
        break;
      case ClickEncoder::Held:
        altmodus = modus;
        modus = 80;
        break;
      case ClickEncoder::Released:
        ButtonPressed = false;
        break;
      case ClickEncoder::Clicked:
        ButtonPressed = true;
        if (ruehrer)
          if (geschwindigkeitsrelais)
            if ((modus == 26) || (modus == 27) || (modus == 28) || (modus == 29) || (modus == 30))
            {
              if (highspeed) {
                digitalWrite(Speedrelais, LOW_SPEED);
              } else {
                digitalWrite(Speedrelais, HIGH_SPEED);
              }
              highspeed = !highspeed;
            }
        break;
      case ClickEncoder::DoubleClicked:
        if (modus != 5)
        {
          altmodus = modus; //Merker für letzten Modus
          tempdrehen = drehen; //Merker für aktuellen Wert von drehen
          anfang = 0;
          dclick = true;  //Doppelclick wurde betätigt
          modus = 5;
          zeitz = false;  //Zeit nicht anhalten
          break;
        }
    }
  }

  if (wlanAktiv) {
    if (loggen)
      if (aio)
      {
        if ((lan_aufruf + 500) < millis())
        {
          lan_aufruf = millis();
          zum_pc();
        }
        zurAiO(100);  //Rezept aus KBH und Menübefehle - alle 200 msec möglich
      }
  }


  if (serialcom) logger_serial();
  if (logview) logger_logview();

  if (heizung == 1)
  {
    if ((heizungInterval1 + 5000) < millis())
    {
      heizungInterval1 = millis();
      mySwitch.send(funk_heizung_ein, 24);
      if (ruehrer)
      {
        rwerk = 0;
        ruehrerEinAus(1);
      }
    }
  }

  if (heizung == 0)
  {
    if ((heizungInterval2 + 5000) < millis())
    {
      heizungInterval2 = millis();
      mySwitch.send(funk_heizung_aus, 24);
    }
  }

  // Zeitermittlung ------------------------------------------------------------------
  sekunden = second();  //aktuell Sekunde abspeichern für die Zeitrechnung
  minutenwert = minute(); //aktuell Minute abspeichern für die Zeitrechnung
  stunden = hour();     //aktuell Stunde abspeichern für die Zeitrechnung
  //----------------------------------------------------------------------------------


  // Temperatursensor DS1820 Temperaturabfrage ---------------------------------------
  sensors.requestTemperatures(); // Temperatur holen
  sensorwert = sensors.getTempC(insideThermometer);
  if ((sensorwert != isttemp) && (n < 10)) // Messfehlervermeidung
  { // des Sensorwertes
    n++;                                   // nach mehreren
  }                                      // Messungen
  else
  {
    isttemp = sensorwert;
    n = 0;
  }
  //----------------------------------------------------------------------------------


  // Sensorfehler --------------------------------------------------------------------
  // Sensorfehler -127 => VCC fehlt
  // Sensorfehler 85.00 => interner Sensorfehler ggf. Leitung zu lang
  //                       nicht aktiviert
  // Sensorfehler 0.00 => Datenleitung oder GND fehlt

  if (regelung == 1) //nur bei Modi mit Heizung
  {
    if ((int)isttemp == -127 || (int)isttemp == 0 ) {
      //zur besseren Erkennung Umwandling in (int)-Wert
      //sonst Probleme mit der Erkennung gerade bei 0.00
      if (sensorfehler == 0)
      {
        rufmodus = modus;
        lcd.clear();
        lcd.setCursor(8, 0);
        lcd.print("Sensorfehler");
        regelung = 0;
        heizung = 0;
        rwerk = 1;
        ruehrerEinAus(0);
        sensorfehler = 1;
        modus = 31;
      }
    } else sensorfehler = 0;
  }
  //--------------------------------------------------------------------------------


  // Temperaturanzeige Istwert -----------------------------------------------------
  if (modus != 5) //nicht im Setup-Menü
  {
    lcd.setCursor(9, 3);
    lcd.print("ist ");
    lcd.print(float(sensorwert), 2);
    if (sensorwert > 10)
    {
      lcd.print(char(0xDF));
      lcd.print("C");
    }
    else
    {
      lcd.print(char(0xDF));
      lcd.print("C ");
    }
  }
  //--------------------------------------------------------------------------------



  //Heizregelung----------------------------------------------------------------------
  if (regelung == 1)
  {
    // Temperaturanzeige Sollwert ----------------------------------------------------
    lcd.setCursor(15, 1);
    lcd.print(int(sollwert), 1);
    lcd.print(char(0xDF)); lcd.print("C ");

    //--------------------------------------------------------------------------------

    if ((modus == 20) || (modus == 27) || (modus == 28) || (modus == 29) || (modus == 30) || (modus == 2) || (modus == 1))  //Maischeautomatik/Nachguss/Kühlen
    {
      lcd.setCursor(0, 0);
      if ((modus != 2) && (modus != 1)) lcd.print("Maischen");
      if ((alte_zeit + messzyklus) < millis()) {
        gradient = (isttemp - alte_temperatur) / (millis() - alte_zeit) * 60000;
        alte_zeit = millis();
        alte_temperatur = isttemp;
      }
      if (modus != 2) {
        lcd.setCursor(0, 1);
        lcd.print(gradient);
        lcd.print(" K/m ");
      }

    }

    //Gradientenregelung--------------------------------------------------------------

    if (modus != 1) { //Heizungsregelung
      if (isttemp > (sollwert - (gradient * kh))) {
        if (heizung == 1) {
          heizung = 0;
          hwarten = millis();
          sollwerterreicht = true;
        }

      }
      if (isttemp <= (sollwert - (gradient * kh))) {
        if ((millis() > (hwarten + esvheizen)) || first) {
          first = false;
          if (isttemp <= sollwert) heizung = 1;
        }
        sollwerterreicht = false;
      }
    }

    if (modus == 1) {  //Kühlregelung
      if (isttemp < (sollwert - (gradient * kk))) {
        if (heizung == 1) {
          heizung = 0;
          hwarten = millis();
        }

      }
      if (isttemp >= (sollwert - (gradient * kk))) {
        if ((millis() > (hwarten + kzeitverz)) || first) {
          first = false;
          if (isttemp >= sollwert) heizung = 1;
        }
      }
    }
  }


  // Zeigt "Heizen" wenn Heizen und "Kühlen wenn Kühlen ----------------------------
  if (heizung == 1)
  {
    if (modus != 5)
    {
      lcd.setCursor(0, 3);
      if (modus != 1) {
        lcd.print("Heizen");
      } else  {
        lcd.print("K");
        lcd.print(char(0xF5));
        lcd.print("hlen");
      }
    }
    digitalWrite(HeizungR1, H_EIN);   // einschalten
    digitalWrite(HeizungR2, H_EIN);   // einschalten

    if (!eingeschaltet)
    { mySwitch.send(funk_heizung_ein, 24); //nicht bei jedem Durchlauf aufrufen
      delay(100);
      eingeschaltet = true;
    }


    if ((modus != 1) && (ruehrer)) if (rwerk == 0) ruehrerEinAus(1);  //nicht im Kühlmodus
    if ((modus != 1) && (pumpe)) intervallbetrieb();
  }
  else
  {
    if (modus != 5)
    {
      lcd.setCursor(0, 3); lcd.print("       ");
    }
    digitalWrite(HeizungR1, H_AUS);   // ausschalten
    digitalWrite(HeizungR2, H_AUS);   // ausschalten

    if (eingeschaltet)
    { mySwitch.send(funk_heizung_aus, 24); //nicht bei jedem Durchlauf aufrufen
      delay(100);
      eingeschaltet = false;
    }

    if (modus != 1)
    { //nicht im Kühlmodus
      if (ruehrer)
      {
        if (dauerbetrieb == 'J') {
          rwerk = 0; // alter Status des Rührers
          // damit nicht fortwährend Daten gesendet werden!
          ruehrerEinAus(1)
          ;
        } //Rührer im Dauerbetrieb
        else if ((heizung == 0) && (regelung == 1) && (modus != 2) && (sollwerterreicht)) intervallbetrieb(); //Rührer im Intervallbetrieb
      }
    } //Ende Ruehrer
    if ((pumpe) && (regelung == 1)) intervallbetrieb();
  }
  //Ende Heizregelung--------------------------------------------------------------


  // Abfrage Modus

  encoder->setAccelerationEnabled(true);
  switch (modus) {
    case 0: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Hauptmenü
        altmodus = 0;
        funktion_hauptschirm();
        break;
      }

    case 1: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;  //Kühlen
        altmodus = 1;
        funktion_temperatur();
        break;
      }

    case 2: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;  //Nachguss
        funktion_temperatur();
        break;
      }

    case 3: {
        regelung = 0;  //Würzepumpe
        wuerzepumpe();
        break;
      }

    case 5: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Einstellungen
        funktion_SetupMenu();
        break;
      }

    case 11: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Gradientenfaktor Heizen
        rufmodus = 0;
        khwert();
        break;
      }

    case 12: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Wartezeit Wiedereinschalten Heizungsrelais
        ESVHeiz();
        break;
      }

    case 13: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Gradientenfaktor Kühlen
        rufmodus = 0;
        kkwert();
        break;
      }

    case 14: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Wartezeit bein Kühlen vor dem Wiedereinschalten
        wartenKuehlen();
        break;
      }

    case 19: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Anzahl Rasten
        funktion_rastanzahl();
        break;
      }
    case 20: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Eingabe Einmaischtemperatur
        funktion_maischtemperatur();
        break;
      }
    case 21: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Eingabe der Temperatur der Rasten
        funktion_rasteingabe();
        break;
      }

    case 22: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Eingabe der Rastzeitwerte
        funktion_zeiteingabe();
        break;
      }

    case 23: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Rührwerk oder Malzrohrpumpe?
        ruehrer_pumpe();
        break;
      }

    case 233: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Rührwerk Dauerlauf?
        ruehrwerk();
        break;
      }

    case 234: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Rührwerk Intervall EIN
        ruehrwerk_ein();
        break;
      }

    case 235: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //Rührwerk Intervall AUS
        ruehrwerk_aus();
        break;
      }

    case 236: {
        //Steckdosencode eingeben
        steckdosencode();
        break;
      }

    case 239: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Kochschwelle - ab hier Brauerruf
        kochschwelle();
        break;
      }

    case 24: {
        regelung = 0;  //Eingabe Braumeisterruf An/Aus
        funktion_braumeister();
        break;
      }

    case 242: {
        // WiFi starten
        connectWiFi();
        break;
      }

    case 243: {
        //WiFi Ein bzw. Aus
        wifieinaus();
        break;
      }

    case 25: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;  //Abmaischtemperatur
        funktion_endtempeingabe();
        break;
      }

    case 26: {
        regelung = 0;  //Start Maischeprozess
        funktion_startabfrage();
        break;
      }

    case 27: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;  //Automatischer Ablauf Maischen
        funktion_maischtemperaturautomatik();
        break;
      }

    case 28: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;
        funktion_tempautomatik();
        break;
      }

    case 29: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;
        funktion_zeitautomatik();
        break;
      }

    case 30: {
        encoder->setAccelerationEnabled(true);
        regelung = 1;
        funktion_endtempautomatik();
        break;
      }

    case 31: {
        regelung = 0;
        funktion_braumeisterrufalarm();
        break;
      }

    case 32: {
        regelung = 0;
        funktion_braumeisterruf();
        break;
      }

    case 37: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;
        anzahl_hopfengaben();
        break;
      }

    case 38: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;
        nachisozeit();
        break;
      }

    case 39: {
        regelung = 0;
        funktion_hopfengabe();
        break;
      }

    case 40: {
        encoder->setAccelerationEnabled(true);
        regelung = 0;
        funktion_kochzeit();
        break;
      }

    case 41: {
        regelung = 0;
        funktion_startkochen();
        break;
      }

    case 42: {
        regelung = 0;
        funktion_kochen();
        break;
      }

    case 43: {
        regelung = 0;
        nachiso();
        break;
      }

    case 44: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //LogViewEinAus
        LoggingEinAus();
        break;
      }

    case 45: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;  //LogViewEinAus
        Logwahl();
        break;
      }

    case 46: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;
        StromAus();  //Notfallmodus Ein/Aus
        break;
      }

    case 80: {
        encoder->setAccelerationEnabled(false);
        regelung = 0;
        funktion_abbruch();
        break;
      }
  }
}
// Ende Loop
//--------------------------------------------------------------------------------


//Funktionen=======================================================================
// ab hier Funktionen

// Funktion Hauptschirm------------------------------------------------------------
void funktion_hauptschirm()      //Modus=0
{

  if ((anfang == 0) || (dclick))

  {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Maischen");
    lcd.setCursor(2, 1);
    lcd.print("Nachguss");
    lcd.setCursor(2, 2);
    lcd.print("Kochen");
    lcd.setCursor(14, 0);
    lcd.print("K"); lcd.print(char(0xF5)); lcd.print("hlen");
    lcd.setCursor(14, 1);
    lcd.print("Pumpe");
    lcd.setCursor(14, 2);
    lcd.print("Setup");
    drehen = 0;
    altdrehen = 0;
    anfang = 1;
    dclick = false;
  }


  if (drehen == 255)
  {
    drehen = 5;
  }
  if (drehen == 6)
  {
    drehen = 0;
  }

  if (drehen != altdrehen)
  {
    lcd.setCursor(0, 0);
    lcd.print("  ");
    lcd.setCursor(0, 1);
    lcd.print("  ");
    lcd.setCursor(0, 2);
    lcd.print("  ");
    lcd.setCursor(12, 0);
    lcd.print("  ");
    lcd.setCursor(12, 1);
    lcd.print("  ");
    lcd.setCursor(12, 2);
    lcd.print("  ");
  }

  if (drehen == 0)
  {
    altdrehen = 0;
    rufmodus = 19;
    lcd.setCursor(0, 0);
    lcd.print("=>");
  }

  if (drehen == 1)
  {
    altdrehen = 1;
    rufmodus = 2;
    lcd.setCursor(0, 1);
    lcd.print("=>");
  }

  if (drehen == 2)
  {
    altdrehen = 2;
    rufmodus = 40;
    lcd.setCursor(0, 2);
    lcd.print("=>");
  }

  if (drehen == 3)
  {
    altdrehen = 3;
    rufmodus = 1;
    lcd.setCursor(12, 0);
    lcd.print("=>");
  }

  if (drehen == 4)
  {
    altdrehen = 4;
    rufmodus = 3;
    lcd.setCursor(12, 1);
    lcd.print("=>");
  }

  if (drehen == 5)
  {
    altdrehen = 5;
    rufmodus = 5;
    lcd.setCursor(12, 2);
    lcd.print("=>");
  }

  if (ButtonPressed)
  {
    modus = rufmodus;
    if (modus == 1)
    { //Übergabe an Modus1
      drehen = EEPROM.read( g_kuehltemp); //ganzzahliger Vorgabewert für Kühlen
      EEPROM.write(k_aktiv, 1); //Kühlmodus bei Stromausfall aktiv
      altmodus = 1;
    }
    if (modus == 2)
    { //Übergabe an Modus2
      drehen = 78;                    //Nachgusstemperatur Sollwert
    }
    anfang = 0;
    lcd.clear();
  }

}
//---------------------------------------------------------------------------------

//Funktion SetupMenu-----------------------------------------------------------------

void funktion_SetupMenu()      //Modus=5
{
  if (anfang == 0)

  {
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Schwelle");
    lcd.setCursor(2, 1);
    lcd.print("R"); lcd.print(char(0xF5)); lcd.print("h/Pump");
    lcd.setCursor(2, 2);
    lcd.print("Funk");
    lcd.setCursor(2, 3);
    lcd.print("Regler");
    lcd.setCursor(13, 0);
    lcd.print("Logging");
    lcd.setCursor(13, 1);
    lcd.print("WLAN");
    lcd.setCursor(13, 2);
    lcd.print("Notfall");
    lcd.setCursor(13, 3);
    lcd.print("Zur"); lcd.print(char(0xF5)); lcd.print("ck");
    drehen = 0;
    altdrehen = 0;
    anfang = 1;
  }


  if (drehen == 255)
  {
    drehen = 7;
  }
  if (drehen == 8)
  {
    drehen = 0;
  }

  if (drehen != altdrehen)
  {
    lcd.setCursor(0, 0);
    lcd.print("  ");
    lcd.setCursor(0, 1);
    lcd.print("  ");
    lcd.setCursor(0, 2);
    lcd.print("  ");
    lcd.setCursor(0, 3);
    lcd.print("  ");
    lcd.setCursor(11, 0);
    lcd.print("  ");
    lcd.setCursor(11, 1);
    lcd.print("  ");
    lcd.setCursor(11, 2);
    lcd.print("  ");
    lcd.setCursor(11, 3);
    lcd.print("  ");
    altdrehen = drehen;
  }

  if (drehen == 0)
  {
    altdrehen = 0;
    rufmodus = 239;
    lcd.setCursor(0, 0);
    lcd.print("=>");
  }

  if (drehen == 1)
  {
    altdrehen = 1;
    rufmodus = 23;
    lcd.setCursor(0, 1);
    lcd.print("=>");
  }

  if (drehen == 2)
  {
    altdrehen = 2;
    rufmodus = 236;
    lcd.setCursor(0, 2);
    lcd.print("=>");
  }

  if (drehen == 3)
  {
    altdrehen = 3;
    rufmodus = 11;
    lcd.setCursor(0, 3);
    lcd.print("=>");
  }

  if (drehen == 4)
  {
    altdrehen = 4;
    rufmodus = 44;
    lcd.setCursor(11, 0);
    lcd.print("=>");
  }

  if (drehen == 5)
  {
    altdrehen = 5;
    rufmodus = 243;
    lcd.setCursor(11, 1);
    lcd.print("=>");
  }

  if (drehen == 6)
  {
    altdrehen = 6;
    rufmodus = 46;
    lcd.setCursor(11, 2);
    lcd.print("=>");
  }

  if (drehen == 7)
  {
    altdrehen = 7;
    rufmodus = altmodus;
    lcd.setCursor(11, 3);
    lcd.print("=>");
  }

  if (ButtonPressed)
  {
    if (dclick) {
      anfang = 1;
    } else {
      anfang = 0;
    }
    modus = rufmodus;
    drehen = tempdrehen;
    first = true;
    lcd.clear();
  }

}

//--------------------------------------------------------------------------------

// Funktion nur Temperaturregelung------------------------------------------------
void funktion_temperatur()      //Modus=1 bzw.2
{

  if (anfang == 0)
  {
    if (modus == 2) drehen = 78;
    anfang = 1;
  }
  if (drehen == 255) drehen = 0;
  sollwert = drehen;


  if (modus == 1)
  {
    lcd.setCursor(0, 0);
    lcd.print("K"); lcd.print(char(0xF5)); lcd.print("hlen");
    lcd.setCursor(10, 1);
    lcd.print("soll");
    altmodus = 1;
  }

  if (modus == 2)
  {
    lcd.setCursor(0, 0);
    lcd.print("Nachguss");

  }

  if ((modus == 2) && (isttemp >= sollwert) && (nachgussruf == false))   //Nachgussruf -> Sollwert erreicht
  {
    nachgussruf = true;
    rufmodus = modus;          //Rufalarm
    modus = 31;
    y = 0;
    braumeister[y] = 2;        //nur Ruf und weiter mit Regelung
  }

}
//---------------------------------------------------------------------------------


void wuerzepumpe()  //Modus = 3
{
  if (anfang == 0)
  {
    lcd.setCursor(0, 0); lcd.print("Pumpe: ");
    anfang = 1;
    anzeige = true;
    warten = millis();
    pwarten = millis();
  }


  digitalWrite(fuellstand_sensor, HIGH);  //PullUp-Widerstand wenn Signal vom Sensor = GND (0V)
  //wenn das Signal vom Sensor = 5V dann realen PullDown-Widerstand (10K) vom Anschluss gegen GND (0V)
  int val = digitalRead(fuellstand_sensor);

  //ist die Pumpe bei Sensor LOW aktiv, dann
  if (val == Sensor_EIN) {
    if (millis() > warten + 1000) {
      if (anzeige)
      {
        lcd.setCursor(0, 1);
        lcd.print("Bitte warten! ");
      }
      warten = millis();
    } else {
      if (anzeige)
      {
        lcd.setCursor(0, 1);
        lcd.print("               ");
      }
    }
    if (millis() > (pwarten + esvpumpen))
    {
      anzeige = false;
      digitalWrite(fuellstand_pumpe, SUDPUMPE_EIN);
      lcd.setCursor(0, 1); lcd.print("                 ");
      lcd.setCursor(7, 0);
      lcd.print("EIN");
    }
  }
  if (val == Sensor_AUS) {
    digitalWrite(fuellstand_pumpe, SUDPUMPE_AUS);
    lcd.setCursor(7, 0);
    lcd.print("AUS");
    pwarten = millis();
    anzeige = true;
  }
}

//--------------------------------------------------------------------------------

// Funktion Eingabe der Rastanzahl------------------------------------------------
void funktion_rastanzahl()          //Modus=19
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Eingabe");
    lcd.setCursor(12, 1);
    lcd.print("Rasten");

    drehen = rasten;
    anfang = 1;
    dclick = false;
  }

  //Vorgabewerte bei verschiedenen Rasten
  if (rasten != drehen)
  {
    if ((int)drehen == 1)
    {
      rastTemp[1] = 67;
      rastZeit[1] = 60;
      maischtemp = 65;
    }
    if (drehen == 2)
    {
      rastTemp[1] = 62;
      rastZeit[1] = 30;
      rastTemp[2] = 72;
      rastZeit[2] = 35;
      maischtemp = 62;
    }
    if (drehen == 3)
    {
      rastTemp[1] = 55;
      rastZeit[1] = 10;
      rastTemp[2] = 62;
      rastZeit[2] = 35;
      rastTemp[3] = 72;
      rastZeit[3] = 25;
      maischtemp = 55;
    }
    if (drehen == 4)
    {
      rastTemp[1] = 40;
      rastZeit[1] = 20;
      rastTemp[2] = 55;
      rastZeit[2] = 15;
      rastTemp[3] = 64;
      rastZeit[3] = 35;
      rastTemp[4] = 72;
      rastZeit[4] = 25;
      maischtemp = 35;
    }
    if (drehen == 5)
    {
      rastTemp[1] = 35;
      rastZeit[1] = 20;
      rastTemp[2] = 40;
      rastZeit[2] = 20;
      rastTemp[3] = 55;
      rastZeit[3] = 15;
      rastTemp[4] = 64;
      rastZeit[4] = 35;
      rastTemp[5] = 72;
      rastZeit[5] = 25;
      maischtemp = 30;
    }
  }

  rasten = drehen;


  if (rasten <= 1)
  {
    rasten = 1;
    drehen = 1;
  }
  if (rasten >= 5)
  {
    rasten = 5;
    drehen = 5;
  }

  lcd.setCursor(19, 1);
  lcd.print(rasten);

  if (ButtonPressed)
  {
    modus++;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------


// Funktion Maischtemperatur--------------------------------------------------------
void funktion_maischtemperatur()      //Modus=20
{

  if ((anfang == 0) || (dclick))
  {
    lcd.setCursor(0, 0);
    lcd.print("Eingabe");
    lcd.setCursor(0, 1);
    lcd.print("Einmaischen         ");
    drehen = maischtemp;
    first = true;
    anfang = 1;
    dclick = false;
  }

  maischtemp = drehen;

  if (maischtemp <= 10)
    maischtemp = 10;

  if (maischtemp >= 105)
    maischtemp = 105;

  lcd.setCursor(16, 1);
  lcd.print(maischtemp);
  lcd.print(char(0xDF)); lcd.print("C ");

  if (ButtonPressed)
  {
    modus++;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------


// Funktion Rasteingabe Temperatur--------------------------------------------------
void funktion_rasteingabe()      //Modus=21
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Eingabe");
    drehen = rastTemp[x];
    anfang = 1;
    dclick = false;
  }

  rastTemp[x] = drehen;

  if (rastTemp[x] <= 10)
  {
    rastTemp[x] = 9;
    drehen = 9;
  }
  if (rastTemp[x] >= 105)
  {
    rastTemp[x] = 105;
    drehen = 105;
  }

  lcd.setCursor(14, 0);
  lcd.print(x);
  lcd.print(".Rast");
  lcd.setCursor(16, 1);
  lcd.print(int(rastTemp[x]));
  lcd.print(char(0xDF)); lcd.print("C ");

  if (ButtonPressed)
  {
    modus++;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------


// Funktion Rasteingabe Zeit--------------------------------------------------------
void funktion_zeiteingabe()      //Modus=22
{

  if ((anfang == 0) || (dclick))
  {
    drehen = rastZeit[x];
    anfang = 1;

    lcd.setCursor(0, 0);
    lcd.print("Eingabe");

    lcd.setCursor(14, 0);
    lcd.print(x);
    lcd.print(".Rast");
    lcd.setCursor(15, 1);
    lcd.print(int(rastTemp[x]));
    lcd.print(char(0xDF)); lcd.print("C ");


    dclick = false;
  }

  rastZeit[x] = drehen;

  if (rastZeit[x] <= 1)
  {
    rastZeit[x] = 1;
    drehen = 1;
  }
  if (rastZeit[x] >= 99)
  {
    rastZeit[x] = 99;
    drehen = 99;
  }

  if (rastZeit[x] < 10)
  {
    lcd.setCursor(14, 2);
    lcd.print(" ");
    lcd.print(int(rastZeit[x]));
    lcd.print(" min");
  }
  else
  {
    lcd.setCursor(14, 2);
    lcd.print(int(rastZeit[x]));
    lcd.print(" min");
  }


  if (ButtonPressed)
  {
    modus = 24;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
void ruehrwerk() //Modus=23
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("R"); lcd.print(char(0xF5)); lcd.print("hrwerk");
    lcd.setCursor(0, 1);
    lcd.print("Dauerbetrieb");
    drehen = EEPROM.read(rdauer);
    anfang = 1;
    dclick = false;
  }

  char antwort = ja_nein[drehen % 2];

  lcd.setCursor(14, 1); lcd.print(antwort);

  dauerbetrieb = antwort;

  if (ButtonPressed)
  {
    if (dauerbetrieb == 'N') {
      modus = 234;
      EEPROM.write(rdauer, 0);
    } else {
      modus = 5;
      EEPROM.write(rdauer, 1);
    }
    speichern();
    anfang = 0;
  }
}

//--------------------------------------------------------------------------------

// Funktion Rührwerk Intervall EIN------------------------------------------------
void ruehrwerk_ein()      //Modus=234
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    if (ruehrer) {
      lcd.print("R");
      lcd.print(char(0xF5));
      lcd.print("hrwerk");
    }
    if (pumpe) {
      lcd.print("Pumpe");
    }
    lcd.setCursor(0, 1);
    lcd.print("Intervall");
    drehen = intervalEin;
    anfang = 1;
    dclick = false;
  }

  if (drehen > 250) drehen = 0;
  intervalEin = drehen;

  if (intervalEin > 9)
  {
    lcd.setCursor(0, 1); lcd.print("Intervall EIN: "); lcd.print(intervalEin); lcd.print("s  ");
  }
  else
  {
    lcd.setCursor(0, 1); lcd.print("Intervall EIN: "); lcd.print(intervalEin); lcd.print("s   ");
  }

  if (ButtonPressed)
  {
    EEPROM.write(ruehrer_ie, intervalEin);
    speichern();
    modus++;
    anfang = 0;
  }
}

//--------------------------------------------------------------------------------

// Funktion Rührwerk Intervall AUS------------------------------------------------

void ruehrwerk_aus()      //Modus=235
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    if (ruehrer) {
      lcd.print("R");
      lcd.print(char(0xF5));
      lcd.print("hrwerk");
    }
    if (pumpe) {
      lcd.print("Pumpe");
    }
    lcd.setCursor(0, 1);
    lcd.print("Intervall");
    drehen = intervalAus;
    anfang = 1;
    dclick = false;
  }

  if (drehen > 250) drehen = 0;

  intervalAus = drehen;

  if (intervalAus > 9)
  {
    lcd.setCursor(0, 1); lcd.print("Intervall AUS: "); lcd.print(intervalAus); lcd.print("s  ");
  }
  else
  {
    lcd.setCursor(0, 1); lcd.print("Intervall AUS: "); lcd.print(intervalAus); lcd.print("s   ");
  }

  if (ButtonPressed)
  {
    EEPROM.write(ruehrer_ia, intervalAus);
    speichern();
    modus = 5;
    anfang = 0;
  }
}

//--------------------------------------------------------------------------------

void steckdosencode() //Modus 233 ------------------------------------------------
{
  if (anfang == 0)
  {
    lcd.clear();
    mySwitch.enableReceive(empfaenger_int);
    anfang = 1;
    drehen = 1;
  }
  else
  {



    if (drehen == 1) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Heizung EIN");
      adr = Heizung_EIN;

    }
    if (drehen == 2) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Heizung AUS");
      adr = Heizung_AUS;
    }
    if (drehen == 3) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruehrer EIN");
      adr = Ruehrer_EIN;
    }
    if (drehen == 4) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruehrer AUS");
      adr = Ruehrer_AUS;
    }
    if (drehen == 5) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruf EIN");
      adr = Ruf_EIN;
    }
    if (drehen == 6) {
      lcd.setCursor(0, 1);
      lcd.print("Taste Ruf AUS");
      adr = Ruf_AUS;
    }

    if (drehen > 6) drehen = 1;

    value = mySwitch.getReceivedValue();
    if (value) {
      // value in EPROM schreiben
      if (EEPROMReadlong(adr) != value) EEPROMWritelong(adr, value);
      lcd.setCursor(0, 2);
      lcd.print("speichern");
      delay(500);
      drehen++;
      if (drehen == 7) {
        modus = 0;
        anfang = 0;
        mySwitch.disableReceive();  //Empfänger wieder deaktivieren
      }
      lcd.clear();
    }
    mySwitch.resetAvailable();

  }
}
//--------------------------------------------------------------------------------

void kochschwelle()  //Modus 239 -------------------------------------------------
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0); lcd.print("Kochschwelle");
    lcd.setCursor(0, 1); lcd.print("Ruf bei:");
    lcd.setCursor(12, 1); lcd.print(char(0xDF)); lcd.print("C ");
    drehen = EEPROM.read(Kochschwelle); //EPROM-Speicher auslesen
    anfang = 1;
    dclick = false;
  }
  else
  {


    if (drehen > 99) drehen = 20;
    if (drehen < 80) drehen = 99;

    kschwelle = drehen;


    lcd.setCursor(9, 1); lcd.print(kschwelle);


    if (ButtonPressed)
    {
      EEPROM.write(Kochschwelle, kschwelle);
      speichern();
      modus = 5;
      anfang = 0;
    }
  }
}
//--------------------------------------------------------------------------------

// Funktion Intervallbetrieb------------------------------------------------------
void intervallbetrieb()
{
  if (regelung == 1)
  {
    unsigned long ein = 1000 * (unsigned long)intervalEin;
    unsigned long aus = 1000 * (unsigned long)intervalAus;

    if (firstinterval)
    {
      intervalstart = millis(); firstinterval = false;
    }
    else if ((intervalstart  + ein)  >= millis()) {
      if (rwerk == 0) ruehrerEinAus(1);
    }
    else if ((intervalstart  + ein + aus) >= millis()) {
      if (rwerk == 1) ruehrerEinAus(0);
    }
    else firstinterval = true;
  }
}

//--------------------------------------------------------------------------------
void ruehrerEinAus(int rueh)
{
  if (modus == 31) // bei Ruf Nachgußbereitung den Rührer nicht einschalten
  {
    delay(100);
    mySwitch.send(funk_ruehrer_aus, 24);
    digitalWrite(RuehrerR2, R_AUS);
    digitalWrite(RuehrerR1, R_AUS);
  }
  else if ((regelung == 1) && (modus != 2)) // außer bei Nachgußbereitung
  {
    if (rueh == 1)
    {
      if (rwerk == 0)
      {
        // Rührer wird eingeschaltet
        delay(100);
        mySwitch.send(funk_ruehrer_ein, 24);
        digitalWrite(RuehrerR2, R_EIN);
        digitalWrite(RuehrerR1, R_EIN);
        rwerk = 1;
      }


    }
    if (rueh == 0)
    {
      if (rwerk == 1)
      {
        //Rührer wird ausgeschaltet
        digitalWrite(RuehrerR2, R_AUS);
        digitalWrite(RuehrerR1, R_AUS);
        mySwitch.send(funk_ruehrer_aus, 24);
        rwerk = 0;
      }
    }
  }
}

//--------------------------------------------------------------------------------

// Funktion Braumeister-----------------------------------------------------------
void funktion_braumeister() //Modus=24
{

  braumeister[x] = 0;
  if (x < rasten)
  {
    x++;
    modus = 21;           //Sprung zur Rasttemperatureingabe
    anfang = 0;
  }
  else
  {
    x = 1;
    modus++;             //Sprung zur Rastzeiteingabe
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------


// Funktion Ende Temperatur-------------------------------------------------------
void funktion_endtempeingabe()      //Modus=25
{

  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Eingabe");
    drehen = endtemp;
    anfang = 1;
  }

  endtemp = drehen;

  if (endtemp <= 10)
    endtemp = 10;

  if (endtemp >= 80)
    endtemp = 80;

  lcd.setCursor(0, 1);
  lcd.print("Abmaischen");
  lcd.setCursor(16, 1);
  lcd.print(int(endtemp));
  lcd.print(char(0xDF)); lcd.print("C ");


  if (ButtonPressed)
  {
    modus++;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------


// Funktion Startabfrage----------------------------------------------------------
void funktion_startabfrage()      //Modus=26
{
  if (anfang == 0)
  {
    lcd.clear();
    anfang = 1;
    altsekunden = millis();
  }

  if (millis() >= (altsekunden + 1000))
  {
    lcd.setCursor(13, 1);
    lcd.print("       ");
    if (millis() >= (altsekunden + 1500))
      altsekunden = millis();
  }
  else
  {
    lcd.setCursor(13, 1);
    lcd.print("Start ?");
  }

  if (ButtonPressed)
  {
    if (notfall_aktiv)
    {


      {
        Notfallmodus = EEPROM.read(0);
        if (EEPROM.read(notfallmodus) != 1) EEPROM.write(notfallmodus, 1); //Notfallmodus aktiviert
        EEPROM.write(Rasten, rasten);
        EEPROM.write(MaischTemp, maischtemp);

        switch (rasten) {
          case 1: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
            }

          case 2: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
              EEPROM.write(rastzeit_2, rastZeit[2]);
              EEPROM.write(rasttemp_2, rastTemp[2]);
            }

          case 3: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
              EEPROM.write(rastzeit_2, rastZeit[2]);
              EEPROM.write(rasttemp_2, rastTemp[2]);
              EEPROM.write(rastzeit_3, rastZeit[3]);
              EEPROM.write(rasttemp_3, rastTemp[3]);
            }

          case 4: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
              EEPROM.write(rastzeit_2, rastZeit[2]);
              EEPROM.write(rasttemp_2, rastTemp[2]);
              EEPROM.write(rastzeit_3, rastZeit[3]);
              EEPROM.write(rasttemp_3, rastTemp[3]);
              EEPROM.write(rastzeit_4, rastZeit[4]);
              EEPROM.write(rasttemp_4, rastTemp[4]);
            }


          case 5: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
              EEPROM.write(rastzeit_2, rastZeit[2]);
              EEPROM.write(rasttemp_2, rastTemp[2]);
              EEPROM.write(rastzeit_3, rastZeit[3]);
              EEPROM.write(rasttemp_3, rastTemp[3]);
              EEPROM.write(rastzeit_4, rastZeit[4]);
              EEPROM.write(rasttemp_4, rastTemp[4]);
              EEPROM.write(rastzeit_5, rastZeit[5]);
              EEPROM.write(rasttemp_5, rastTemp[5]);
            }

          case 6: {
              EEPROM.write(rastzeit_1, rastZeit[1]);
              EEPROM.write(rasttemp_1, rastTemp[1]);
              EEPROM.write(rastzeit_2, rastZeit[2]);
              EEPROM.write(rasttemp_2, rastTemp[2]);
              EEPROM.write(rastzeit_3, rastZeit[3]);
              EEPROM.write(rasttemp_3, rastTemp[3]);
              EEPROM.write(rastzeit_4, rastZeit[4]);
              EEPROM.write(rasttemp_4, rastTemp[4]);
              EEPROM.write(rastzeit_5, rastZeit[5]);
              EEPROM.write(rasttemp_5, rastTemp[5]);
              EEPROM.write(rastzeit_6, rastZeit[6]);
              EEPROM.write(rasttemp_6, rastTemp[6]);
            }
        }
      }
    }

    anfang = 0;
    modus++;
  }
}
//--------------------------------------------------------------------------------


// Funktion Automatik Maischtemperatur--------------------------------------------
void funktion_maischtemperaturautomatik()      //Modus=27
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Maischen");
    drehen = maischtemp;    //Zuordnung Encoder
    anfang = 1;
    dclick = false;
    if (notfall_aktiv) EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
  }

  maischtemp = drehen;

  sollwert = maischtemp;

  if (isttemp >= sollwert)  // Sollwert erreicht ?
  {
    altmodus = modus;
    modus++;
    rufmodus = modus;
    y = 0;
    braumeister[y] = 1;
    modus = 31;
  }
}
//--------------------------------------------------------------------------------

// Funktion Automatik Temperatur--------------------------------------------------
void funktion_tempautomatik()      //Modus=28
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(14, 0);
    lcd.print(x);
    lcd.print(".Rast");

    firstinterval = true;  //Intervallbetrieb Rührwerk
    rwerk = 0;

    drehen = rastTemp[x];
    anfang = 1;
    first = true;
    dclick = false;
    if (notfall_aktiv)
    {
      EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
      EEPROM.write(rastnr, x);
      EEPROM.write(rasttemp_aktuell, rastTemp[x]);
      EEPROM.write(rastzeit_aktuell, rastZeit[x]);
    }
  }

  rastTemp[x] = drehen;

  sollwert = rastTemp[x];


  if (isttemp >= sollwert)  // Sollwert erreicht ?
  {
    modus++;                //zur Zeitautomatik
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

// Funktion Automatik Zeit--------------------------------------------------------
void funktion_zeitautomatik()      //Modus=29
{
  if (anfang == 0)
  {
    drehen = rastZeit[x];              //Zuordnung für Encoder
    signalende = false;
    if (altx != x) zeitz = true;  //bei Rastwechsel Zeit wieder bei 0 starten!

    if (notfall_aktiv)
    {
      EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
      EEPROM.write(rastnr, x);
      EEPROM.write(rasttemp_aktuell, rastTemp[x]);
      EEPROM.write(rastzeit_aktuell, rastZeit[x]);
    }
  }
  altx = x;
  lcd.setCursor(14, 0);
  lcd.print(x);
  lcd.print(".Rast");
  

  if (rastZeit[x] < 10)
  {
    lcd.setCursor(14, 2);
    lcd.print(" ");
    lcd.print(int(rastZeit[x]));
    lcd.print(" min");
  }
  else
  {
    lcd.setCursor(14, 2);
    lcd.print(int(rastZeit[x]));
    lcd.print(" min");
  }

  // Zeitzählung------------------------------------------------------------------
  if (anfang == 0)
  {
    if (zeitz) setTime(00, 00, 00, 00, 01, 01); //.........Sekunden auf 0 stellen
    
 //   setTime(00, 00, 00, 00, 01, 01); //.........Sekunden auf 0 stellen

    if (zeit_setzen) {
      RastZeit_h = EEPROM.read(zeit_h);
      RastZeit_m = EEPROM.read(zeit_m);
      RastZeit_s = EEPROM.read(zeit_s);
      setTime(RastZeit_h, RastZeit_m, RastZeit_s, 00, 01, 01);
      zeit_setzen = false;
    }

    sekunden = second();  //aktuell Sekunde abspeichern für die Zeitrechnung
    minutenwert = minute(); //aktuell Minute abspeichern für die Zeitrechnung
    stunden = hour();     //aktuell Stunde abspeichern für die Zeitrechnung

    lcd.setCursor(0, 2);
    lcd.print("        ");
    anfang = 1;
    
  }

  lcd.setCursor(0, 2);

  if (sekunden < 10)
  {
    if (minuten == 0)
    { lcd.setCursor(1, 2);
      lcd.print("00:0"); lcd.print(sekunden);
    }
  }
  else
  {
    if (minuten == 0)
    { lcd.setCursor(1, 2);
      lcd.print("00:"); lcd.print(sekunden);
    }
  }


  if (stunden == 0)
    minuten = minutenwert;
  else
    minuten = ((stunden * 60) + minutenwert);

  if ((minuten < 10) && (minuten > 0))
  {
    lcd.setCursor(1, 2);
    lcd.print("0"); lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if ((minuten >= 10) && (minuten < 100))
  {
    lcd.setCursor(1, 2);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if (minuten >= 100)
  {
    lcd.setCursor(0, 2);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  // Ende Zeitzählung---------------------------------------------------------------

  //Zustand für den Fall von Stromausfall speichern---------------------------------

  if (notfall_aktiv)
  {
    if (sekunden == 0)  //einmal pro Minute speichern
    {
      EEPROM.write(rastnr, x);
      EEPROM.write(rasttemp_aktuell, rastTemp[x]);
      EEPROM.write(rastzeit_aktuell, rastZeit[x]);
      EEPROM.write(zeit_h, stunden);
      EEPROM.write(zeit_m, minuten);
      EEPROM.write(zeit_s, sekunden);
    }
  }

  //--------------------------------------------------------------------------------

  //Erinnerung Jodprobe-------------------------------------------------------------

  if (x == rasten)
  {
    if ((minuten >= rastZeit[x] - 5) && (!signalende)) //5 min. vor Ende der letzten Rast
    {
      lcd.setCursor(0, 3); lcd.print("Jodprobe!");
      for (tz = 0; tz <= 5; tz++){signalton(500); delay(200);}
      signalende = true;
      lcd.setCursor(0, 3); lcd.print("         ");
    }

    
  }

  //--------------------------------------------------------------------------------

  
  if (drehen == 255) drehen = 0;
  rastZeit[x] = drehen;   //Encoderzuordnung
  

  if (minuten >= rastZeit[x])  // Sollwert erreicht ?
  {
    anfang = 0;
    y = x;



    if (x < rasten)
    {
      modus--;                // zur Temperaturregelung
      x++;                    // nächste Stufe
    }
    else
    {
      x = 1;                              //Endtemperatur
      modus++;                            //Endtemperatur
    }

    if (braumeister[y] > 0)
    {
      rufmodus = modus;
      modus = 31;
    }
  }
}
//--------------------------------------------------------------------------------

// Funktion Automatik Endtemperatur-----------------------------------------------
void funktion_endtempautomatik()      //Modus=30
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(10, 0);
    lcd.print("Abmaischen");

    drehen = endtemp;    //Zuordnung Encoder
    anfang = 1;
    dclick = false;
    if (notfall_aktiv)
      EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
  }

  endtemp = drehen;

  sollwert = endtemp;

  if (isttemp >= sollwert)  // Sollwert erreicht ?
  {
    modus = 80;                //Abbruch
    rufmodus = modus;
    modus = 31;
    regelung = 0;              //Regelung aus
    heizung = 0;               //Heizung aus
    y = 0;
    braumeister[y] = 1;
  }
}
//--------------------------------------------------------------------------------

// Funktion braumeisterrufalarm---------------------------------------------------
void funktion_braumeisterrufalarm()      //Modus=31
{
  if (anfang == 0)
  {
    rufsignalzeit = millis();
    altsekunden = millis();
    anfang = 1;
  }

  if (altmodus == 27) //Einmaischtemperatur erreicht !
  {
    altmodus = 31;
    heizung = 0;
    rwerk = 1;
    ruehrerEinAus(0);
  }

  if (millis() >= (altsekunden + 1000)) //Blinken der Anzeige und RUF
  {
    lcd.setCursor(17, 2);
    lcd.print("   ");
    digitalWrite(RufR, B_AUS);

    if (millis() >= (altsekunden + 1500))
    {
      altsekunden = millis();
      pause++;
    }
  }
  else
  {
    lcd.setCursor(17, 2);
    lcd.print("Ruf");
    if (pause <= 4)
    {
      digitalWrite(RufR, B_EIN);

    }
    if (pause > 8)
      pause = 0;
  }                                   //Blinken der Anzeige und RUF

  //20 Sekunden Rufsignalisierung wenn "Ruf Signal"
  if (braumeister[y] == 2 && millis() >= (rufsignalzeit + 20000))
  {
    anfang = 0;
    pause = 0;
    digitalWrite(RufR, B_AUS);   // Alarm ausschalten

    modus = rufmodus;
    lcd.setCursor(17, 2);
    lcd.print("   ");
  }
  //weiter mit Programmablauf

  if (ButtonPressed)
  {
    pause = 0;
    anfang = 0;
    digitalWrite(RufR, B_AUS);   // Alarm ausschalten

    if (braumeister[y] == 2)
    {
      lcd.setCursor(17, 2);
      lcd.print("   ");
      if (sensorfehler == 1) {
        sensorfehler = 0;  //Sensorfehler oder Alarmtest
        lcd.setCursor(8, 0);
        lcd.print("            ");
      }
      modus = rufmodus;
    }
    else
      modus++;
  }
}
//--------------------------------------------------------------------------------

// Funktion braumeisterruf--------------------------------------------------------
void funktion_braumeisterruf()      //Modus=32
{
  if (anfang == 0)
  {
    anfang = 1;
  }


  if (millis() >= (altsekunden + 1000))
  {
    lcd.setCursor(12, 2);
    lcd.print("        ");
    if (millis() >= (altsekunden + 1500))
      altsekunden = millis();
  }
  else
  {
    lcd.setCursor(0, 2); lcd.print("            ");
    lcd.setCursor(12, 2);
    lcd.print("weiter ?");
  }

  if (ButtonPressed)
  {

    lcd.setCursor(12, 2);
    lcd.print("        ");  //Text "weiter ?" löschen

    lcd.setCursor(0, 3);
    lcd.print("             "); //Löscht Text bei
    if (sensorfehler == 1) {
      sensorfehler = 0;  //Sensorfehler oder Alarmtest
      lcd.setCursor(8, 0);
      lcd.print("            ");
    }

    anfang = 0;
    modus = rufmodus;
    if (rufmodus == 42) {
      anfang = 1;   // Hopfen zugegeben!
      lcd.setCursor(0, 2);
      lcd.print("                    ");
    }

    delay(500);     //kurze Wartezeit, damit nicht
    //durch unbeabsichtigtes Drehen
    //der nächste Vorgabewert
    //verstellt wird
  }
}
//--------------------------------------------------------------------------------

void anzahl_hopfengaben() //Modus=37 ---------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Hopfengaben");
    lcd.setCursor(5, 1);
    lcd.print("Anzahl");
    anfang = 1;
    drehen = hanz;
    lcd.setCursor(14, 1);
    lcd.print(hanz);
    dclick = false;
  }


  if (hanz < 9)
  {
    lcd.setCursor(14, 1); lcd.print(hanz);
  }
  else
  {
    lcd.setCursor(13, 1); lcd.print(hanz);
  }

  hanz = drehen;

  if (drehen >= maxgaben)
  {
    hanz = maxgaben; drehen = maxgaben;
  }

  if (drehen <  2)
  {
    hanz = 1; drehen = 1;
  }

  if (ButtonPressed)
  {
    modus = 38;
    anfang = 0;
  }
}

//------------------------------------------------------------------------------

void nachisozeit() //Modus=38 --------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nachisomerisierung");
    lcd.setCursor(0, 1);
    lcd.print("Zeit:");
    drehen = nachisomerisierung;
    anfang = 1;
    dclick = false;
  }

  lcd.setCursor(6, 1); lcd.print(nachisomerisierung); lcd.print("  min. ");

  nachisomerisierung = drehen;

  if (ButtonPressed)
  {
    modus = 39;
    anfang = 0;
  }
}

//--------------------------------------------------------------------------------

// Funktion Hopfengabe------------------------------------------------------------
void funktion_hopfengabe()      //Modus=39
{
  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Hopfengabe:");
    lcd.setCursor(0, 1);
    lcd.print("Kochen ");
    lcd.print("f"); lcd.print(char(0xF5)); lcd.print("r");

    if (kochzeit >= 60)  // weniger ist eigentlich nicht sinnvoll
    {
      if (h == 0) hopfengabe[h] = kochzeit;  //Typische Zeiten für das Hopfenkochen
      if (h == 1) hopfengabe[h] = kochzeit - 20;
      if (h == 2) hopfengabe[h] = 10;
    }

    drehen = hopfengabe[h];

    anfang = 1;
    dclick = false;
  }
  lcd.setCursor(11, 0); lcd.print(h + 1);

  hopfengabe[h] = drehen;
  lcd.setCursor(12, 1);

  lcd.print(drehen);


  lcd.print(" min ");

  if (hopfengabe[h] <= 0)
  {
    hopfengabe[h] = 0;
    drehen = 0;
  }
  if (hopfengabe[h] >= kochzeit)
  {
    hopfengabe[h] = kochzeit;
    drehen = kochzeit;
  }



  if (ButtonPressed)
  {
    if (h == (hanz - 1)) {
      lcd.clear();
      modus = 41;

    } else {
      h++;
    }
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

// Funktion Kochzeit--------------------------------------------------------------
void funktion_kochzeit()      //Modus=40
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Aufheizen");
    lcd.setCursor(4, 1);
    lcd.print("Kochzeit");
    lcd.setCursor(17, 1);
    lcd.print("min");

    lcd.setCursor(2, 2);
    lcd.print("Dr"); lcd.print(char(0xF5)); lcd.print("cken = weiter");

    drehen = kochzeit;

    heizung = 1; //Heizung einschalten
    rwerk = 1;
    ruehrerEinAus(0);

    anfang = 1;
    dclick = false;
  }

  kochzeit = drehen; //5min-Sprünge

  if (kochzeit <= 20)
  {
    kochzeit = 20;
    drehen = 20;
  }
  if (kochzeit >= 180)
  {
    kochzeit = 180;
    drehen = 180;
  }

  if (kochzeit < 100)
  {
    lcd.setCursor(12, 1);
    lcd.print("  ");
    lcd.print(kochzeit);
  }
  else
  {
    lcd.setCursor(12, 1);
    lcd.print(" ");
    lcd.print(kochzeit);
  }

  if (ButtonPressed)
  {
    modus = 37; // Anzahl Hopfengaben
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

// Funktion Startkochzeit---------------------------------------------------------
void funktion_startkochen()      //Modus=41
{
  if ((anfang == 0) || (dclick))
  {
    anfang = 1;
    altsekunden = millis();
    abbruchkochen = 60;
    blinker = 0;
    dclick = false;
    sollwert = kschwelle;
  }
  lcd.setCursor(0, 0); lcd.print("Ruf bei "); lcd.print(kschwelle); lcd.print(char(0xDF)); lcd.print("C"); lcd.print("  ");
  if (millis() <= (altsekunden + 1000))
  {

    if ((isttemp >= kschwelle) || (schwelle_erreicht))
    {

      schwelle_erreicht = true;
      if (anfang != 3) {
        lcd.setCursor(0, 1);
        lcd.print("Abbruch in ");
        if (abbruchkochen <= 60) {
          lcd.print(abbruchkochen);
          lcd.print(" s ");
        }
      }
      lcd.setCursor(0, 2);
      if (blinker == 0)
      {
        if (anfang == 3)
        {
          lcd.print("Start Zeitz");
          lcd.print(char(0xE1));
          lcd.print("hlung?");
        }
        else
        {
          lcd.print("Bitte quittieren!");
        }
        if (anfang == 1) {
          signalton(500);
          anfang = 2;
        } else if (anfang == 2)
        { if (abbruchkochen > 61) modus = 80;
          if (abbruchkochen % 10 == 0) signalton(500);
        }
      }
      else lcd.print("                   ");

    }
    else
    {
      if (blinker == 0)
      {
        lcd.setCursor(0, 2);
        lcd.print("Warten!");
        schwelle_erreicht = false;
      }

      if (blinker == 1)
      {
        lcd.setCursor(0, 2);
        lcd.print("                   ");
      }
    }

  } else {
    if (blinker == 0) blinker = 1;
    else blinker = 0;
    altsekunden = millis();
    if (schwelle_erreicht) abbruchkochen--;
  }

  if (schwelle_erreicht)
  {
    if (ButtonPressed)
    {
      if (anfang == 3)
      {
        anfang = 0;
        lcd.setCursor(0, 2); lcd.print("               ");
        modus = 42;
      }
      if (anfang == 2) {
        anfang = 3;
        lcd.setCursor(0, 1);
        lcd.print("                    ");
      }

    }
  }
}
//--------------------------------------------------------------------------------

// Funktion Kochen----------------------------------------------------------------
void funktion_kochen()      //Modus=42
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Kochen");
    lcd.setCursor(4, 1);
    lcd.print("Kochzeit "); lcd.print(kochzeit); lcd.print(" min. ");
    //    lcd.setCursor(17, 1);
    //    lcd.print("min");

    if (!dclick) setTime(00, 00, 00, 00, 01, 01); //.........Sekunden auf 0 stellen

    if (zeit_setzen) {
      RastZeit_h = EEPROM.read(zeit_h);
      RastZeit_m = EEPROM.read(zeit_m);
      RastZeit_s = EEPROM.read(zeit_s);
      setTime(RastZeit_h, RastZeit_m, RastZeit_s, 00, 01, 01);
      zeit_setzen = false;
    }

    if (notfall_aktiv)
    {
      Notfallmodus = EEPROM.read(0);
      if (EEPROM.read(notfallmodus) != 1) EEPROM.write(notfallmodus, 1); //Notfallmodus aktiviert
      EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
      EEPROM.write(hopfengabe1, hopfengabe[0]);
      EEPROM.write(hopfengabe2, hopfengabe[1]);
      EEPROM.write(hopfengabe3, hopfengabe[2]);
      EEPROM.write(hopfengabe4, hopfengabe[3]);
      EEPROM.write(hopfengabe5, hopfengabe[4]);
      EEPROM.write(hopfengabe6, hopfengabe[5]);
      EEPROM.write(Kochzeit, kochzeit);
    }

    delay(400); //Anzeigepause

    sekunden = second();  //aktuell Sekunde abspeichern für die Zeitrechnung
    minutenwert = minute(); //aktuell Minute abspeichern für die Zeitrechnung
    stunden = hour();     //aktuell Stunde abspeichern für die Zeitrechnung

    anfang = 1;
    if (!dclick) h = 0;  //Hopfengabengabe Zähler
    drehen = kochzeit;
    dclick = false;
  }

  if (kochzeit < 100)
  {
    lcd.setCursor(12, 1);
    lcd.print("    ");
    lcd.print(kochzeit);
  }
  else
  {
    lcd.setCursor(12, 1);
    lcd.print(" ");
    lcd.print(kochzeit);
  }

  lcd.setCursor(13, 1); lcd.print(kochzeit); lcd.print(" min. ");

  if (sekunden < 10)
  {
    if (minuten == 0)
    { lcd.setCursor(14, 0);
      lcd.print("00:0"); lcd.print(sekunden);
    }
  }
  else
  {
    if (minuten == 0)
    { lcd.setCursor(14, 0);
      lcd.print("00:"); lcd.print(sekunden);
    }
  }

  minuten = ((stunden * 60) + minutenwert);

  if ((kochzeit - minuten == hopfengabe[h]) && (h < hanz))
  {
    lcd.setCursor(0, 2); lcd.print(h + 1); lcd.print(". H-Gabe");
    h++;
    signalton(2000);
  }

  if ((sekunden + 10) % 30 == 0) {
    lcd.setCursor(0, 2);
    lcd.print("          ");
  }


  if ((minuten < 10) && (minuten > 0))
  {
    lcd.setCursor(14, 0);
    lcd.print("0"); lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if ((minuten >= 10) && (minuten < 100))
  {
    lcd.setCursor(14, 0);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if (minuten >= 100)
  {
    lcd.setCursor(13, 0);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  kochzeit = drehen;

  if (kochzeit <= 20)
  {
    kochzeit = 20;
    drehen = 20;
  }
  if (kochzeit >= 180)
  {
    kochzeit = 180;
    drehen = 180;
  }

  if (notfall_aktiv)
  {

    if (sekunden == 0)  //einmal pro Minute speichern
    {
      EEPROM.write(zeit_h, stunden);
      EEPROM.write(zeit_m, minuten);
      EEPROM.write(zeit_s, sekunden);
    }
  }

  if (minuten >= kochzeit)     //Kochzeitende
  {
    modus = 80;                //Abbruch nach Rufalarm
    rufmodus = modus;
    modus = 31;
    regelung = 0;              //Regelung aus
    heizung = 0;               //Heizung aus
    y = 0;
    braumeister[y] = 2;
    anfang = 0;
    if (nachisomerisierung > 0) {
      rufmodus = 43;
    }
  }

}
//--------------------------------------------------------------------------------

// Funktion Nachisomerisierung----------------------------------------------------
void nachiso()      //Modus=43
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Nachisom.");
    lcd.setCursor(0, 1);
    lcd.print("Wartezeit: ");
    lcd.setCursor(12, 1);
    lcd.print("min");

    if (!dclick) setTime(00, 00, 00, 00, 01, 01); //.........Sekunden auf 0 stellen

    if (zeit_setzen) {
      nachiso_h = EEPROM.read(isozeit_h);
      nachiso_m = EEPROM.read(isozeit_m);
      nachiso_s = EEPROM.read(isozeit_s);
      setTime(nachiso_h, nachiso_m, nachiso_s, 00, 01, 01);
      zeit_setzen = false;
    }

    if (notfall_aktiv)
    {
      Notfallmodus = EEPROM.read(0);
      if (EEPROM.read(notfallmodus) != 1) EEPROM.write(notfallmodus, 1); //Notfallmodus aktiviert
      EEPROMWritelong(rastmodus, modus); //für Notfall Modus merken
      EEPROM.write(niso, nachisomerisierung);
    }

    delay(400); //Anzeigepause

    sekunden = second();  //aktuell Sekunde abspeichern für die Zeitrechnung
    minutenwert = minute(); //aktuell Minute abspeichern für die Zeitrechnung
    stunden = hour();     //aktuell Stunde abspeichern für die Zeitrechnung

    anfang = 1;
    drehen = nachisomerisierung;
    dclick = false;
  }

  if (nachisomerisierung < 100)
  {
    lcd.setCursor(12, 1);
    lcd.print("  ");
    lcd.print(nachisomerisierung); lcd.print(" min. ");
  }
  else
  {
    lcd.setCursor(12, 1);
    lcd.print(" ");
    lcd.print(nachisomerisierung); lcd.print(" min. ");
  }

  if (sekunden < 10)
  {
    if (minuten == 0)
    { lcd.setCursor(14, 0);
      lcd.print("00:0"); lcd.print(sekunden);
    }
  }
  else
  {
    if (minuten == 0)
    { lcd.setCursor(14, 0);
      lcd.print("00:"); lcd.print(sekunden);
    }
  }

  minuten = ((stunden * 60) + minutenwert);

  if ((minuten < 10) && (minuten > 0))
  {
    lcd.setCursor(14, 0);
    lcd.print("0"); lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if ((minuten >= 10) && (minuten < 100))
  {
    lcd.setCursor(14, 0);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  if (minuten >= 100)
  {
    lcd.setCursor(13, 0);
    lcd.print(minuten); lcd.print(":");
    if (sekunden < 10) {
      lcd.print("0");
      lcd.print(sekunden);
    } else lcd.print(sekunden);
  }

  nachisomerisierung = drehen;

  if (notfall_aktiv)
  {

    if (sekunden == 0)  //einmal pro Minute speichern
    {
      EEPROM.write(isozeit_h, stunden);
      EEPROM.write(isozeit_m, minuten);
      EEPROM.write(isozeit_s, sekunden);
    }
  }

  if ((minuten >= nachisomerisierung) || (isttemp <= isoTemperatur))    //Nachisomerisierung Ende
  {
    modus = 80;                //Abbruch nach Rufalarm
    rufmodus = modus;
    modus = 31;
    y = 0;
    braumeister[y] = 2;
    anfang = 0;
  }

}
//--------------------------------------------------------------------------------

void khwert() //Modus=11 ---------------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Faktor Heizen");
    lcd.setCursor(0, 1);
    lcd.print("kh = ");

    kh =  EEPROMReadlong(graf_h);
    anfang = 1;
    drehen = kh;
    dclick = false;
  }

  if (drehen < 0) drehen = 200;
  if (drehen > 200) drehen = 0;


  kh  = drehen;
  lcd.setCursor(5, 1); lcd.print(kh / 10); lcd.print(' ');

  if (ButtonPressed)
  {
    if (EEPROMReadlong(graf_h) != drehen) EEPROMWritelong(graf_h, drehen);
    speichern();
    modus = 12;
    kh /= 10;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

void ESVHeiz() //Modus=12 --------------------------------------------------------
{

  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Einschaltv. Heizen");
    lcd.setCursor(0, 1);
    lcd.print("ESVH = ");

    esvheizen =  EEPROMReadlong(wein_h);
    anfang = 1;
    drehen = esvheizen / 1000;
  }

  if (drehen < 0) drehen = 60;
  if (drehen > 60) drehen = 0;

  lcd.setCursor(7, 1); lcd.print(drehen); lcd.print(" s ");

  esvheizen = drehen * 1000L;

  if (ButtonPressed)

  {
    if (EEPROMReadlong(wein_h) != esvheizen) EEPROMWritelong(wein_h, esvheizen);
    speichern();
    modus = 13;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

void kkwert() //Modus=13 ---------------------------------------------------------
{

  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Faktor Kuehlen");
    lcd.setCursor(0, 1);
    lcd.print("kk = ");

    kk =  EEPROMReadlong(graf_k);
    anfang = 1;
    drehen = kk;
  }

  if (drehen < 0) drehen = 200;
  if (drehen > 200) drehen = 0;


  kk  = drehen;
  lcd.setCursor(5, 1); lcd.print(kk / 10); lcd.print(' ');




  if (ButtonPressed)
  {
    if (EEPROMReadlong(graf_k) != drehen) EEPROMWritelong(graf_k, drehen);
    speichern();
    modus = 14;
    kk /= 10;
    anfang = 0;
  }
}
//--------------------------------------------------------------------------------

// Funktion Einschaltverzögerung Kühlen (Kompressorschutz)------------------------

void wartenKuehlen()  //Modus 14
{
  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0); lcd.print("Wartezeit Kuehlen");
    lcd.setCursor(0, 1);
    lcd.print("ESVK = ");
    kzeitverz = EEPROMReadlong(kuehlverz);
    kzeitverz = kzeitverz / (60000);
    drehen = kzeitverz;
    anfang = 1;
  }
  else
  {

    kzeitverz = drehen;


    lcd.setCursor(7, 1); lcd.print(kzeitverz); lcd.print(" min  ");

    if (ButtonPressed)
    {
      EEPROMWritelong(kuehlverz, kzeitverz * 60000);
      kzeitverz = kzeitverz * 60000;
      speichern();
      modus = 5;
      anfang = 0;
    }
  }
}
//-------------------------------------------------------------------------------------

void LoggingEinAus() //Modus=44 -------------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Logging Ein?");
    drehen = EEPROM.read(logging);
    anfang = 1;
    dclick = false;
  }

  if (drehen > 1) drehen = 0;
  if (drehen < 0) drehen = 1;

  lcd.setCursor(0, 1); if (drehen == 1) lcd.print("J"); else lcd.print("N");

  loggen = drehen;


  if (ButtonPressed)
  {
    modus = 5;
    if (EEPROM.read(logging) != drehen) EEPROM.write(logging, drehen);
    if (loggen) {
      Serial.begin(115200);  // Serielle Schnittstelle für Logging
      modus = 45;
    }
    else Serial.end();
    speichern();
    anfang = 0;
  }
}
//-------------------------------------------------------------------------------------

void Logwahl() //Modus=45 -------------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Loggerwahl");
    lcd.setCursor(0, 1);
    lcd.print("SerialCom:");
    lcd.setCursor(0, 2);
    lcd.print("LogView  :");
    lcd.setCursor(13, 1);
    lcd.print("AiO :");

    drehen = EEPROM.read(loggerwahl);
    anfang = 1;
    dclick = false;
  }

  if (drehen > 3) drehen = 0;
  if (drehen < 0) drehen = 2;

  if (drehen == 0) {
    lcd.setCursor(11, 1);
    lcd.print("<-");
    lcd.setCursor(11, 2);
    lcd.print("  ");
    lcd.setCursor(18, 1);
    lcd.print("  ");
  }
  if (drehen == 1) {
    lcd.setCursor(11, 1);
    lcd.print("  ");
    lcd.setCursor(11, 2);
    lcd.print("<-");
    lcd.setCursor(18, 1);
    lcd.print("  ");
  }
  if (drehen == 2) {
    lcd.setCursor(11, 1);
    lcd.print("  ");
    lcd.setCursor(11, 2);
    lcd.print("  ");
    lcd.setCursor(18, 1);
    lcd.print("<-");
  }


  loggen = drehen;


  if (ButtonPressed)
  {
    modus = 5;
    if (EEPROM.read(loggerwahl) != drehen) EEPROM.write(loggerwahl, drehen);
    switch (drehen)
    {
      case 0 : {
          serialcom = true;
          logview = false;
          aio = false;
          break;
        }
      case 1 : {
          logview = true;
          serialcom = false;
          aio = false;
          break;
        }
      case 2:  {
          aio = true;
          serialcom = false;
          logview = false;
          break;
        }
    }
    speichern();
    anfang = 0;
  }
}
//-------------------------------------------------------------------------------------

void ruehrer_pumpe() //Modus=23 -------------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("R"); lcd.print(char(0xF5)); lcd.print("hrer oder Pumpe?");
    lcd.setCursor(0, 1);
    lcd.print("R"); lcd.print(char(0xF5)); lcd.print("hrer  :");
    lcd.setCursor(0, 2);
    lcd.print("Pumpe   :");

    drehen = EEPROM.read(umwaelzwahl);

    if (drehen == 0) {
      lcd.setCursor(11, 1);
      lcd.print("<-");
      lcd.setCursor(11, 2);
      lcd.print("  ");
    }

    if (drehen == 1) {
      lcd.setCursor(11, 1);
      lcd.print("  ");
      lcd.setCursor(11, 2);
      lcd.print("<-");
    }
    anfang = 1;
    dclick = false;
  }

  if (drehen > 2) drehen = 0;
  if (drehen < 0) drehen = 2;

  if (drehen == 0) {
    lcd.setCursor(11, 1);
    lcd.print("<-");
    lcd.setCursor(11, 2);
    lcd.print("  ");

  }
  if (drehen == 1) {
    lcd.setCursor(11, 1);
    lcd.print("  ");
    lcd.setCursor(11, 2);
    lcd.print("<-");
  }

  umwaelzen = drehen;


  if (ButtonPressed)
  {
    if (EEPROM.read(umwaelzwahl) != drehen) EEPROM.write(umwaelzwahl, drehen);
    switch (drehen)
    {
      case 0 : {
          ruehrer = true;
          pumpe = false;
          break;
        }
      case 1 : {
          ruehrer = false;
          pumpe = true;
          aio = false;
          break;
        }
    }
    speichern();
    anfang = 0;
    if (ruehrer) modus = 233;
    if (pumpe) modus = 234;
  }
}
//-------------------------------------------------------------------------------------

void StromAus() //Modus=46 ------------------------------------------------------------
{

  if ((anfang == 0) || (dclick))
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Notfall Ein?");
    drehen = EEPROM.read(notfall);
    anfang = 1;
    dclick = false;
  }

  if (drehen > 1) drehen = 0;
  if (drehen < 0) drehen = 1;

  lcd.setCursor(0, 1); if (drehen == 1) lcd.print("J"); else lcd.print("N");

  notfall_aktiv = drehen;


  if (ButtonPressed)
  {
    modus = 5;
    if (EEPROM.read(notfall) != drehen) EEPROM.write(notfall, drehen);
    speichern();
    anfang = 0;
  }
}
//-------------------------------------------------------------------------------------


void connectWiFi()   //Modus=242 ------------------------------------------------
{
  lcd.clear();
  pinMode(reset8266, OUTPUT);
  digitalWrite(reset8266, LOW);
  lcd.setCursor(0, 0); lcd.print("Init ESP8266");
  delay(2000);
  digitalWrite(reset8266, HIGH);                        //Hardware Reset
  delay(2000);
  if (Serial2.available())
  {
    Serial2.begin(115200);
    delay(5000);
    Serial2.print("AT+RST\r\n");                          //Software Reset
    getReply( 2000 );
    Serial2.print("AT+CIOBAUD=115200\r\n");               //Einstellen der Baudrate
    getReply( 2000 );

    Serial.println("Start\r\n\r\n");
    lcd.setCursor(0, 1); lcd.print("Start WLAN");
    lcd.setCursor(0, 2); lcd.print("Param. UPD ESP8266");
    Serial.println("Modul Reset");
    Serial2.print("AT+RST\r\n");                          //Software Reset
    getReply( 2000 );
    Serial.println("Firmware");
    Serial2.print("AT+GMR\r\n");                          //Ausgabe der Firmware
    getReply( 2000 );


    strcpy(command, "AT+CWSAP=");                         //Zugangsdaten und Verschlüsselung
    strcat(command, "\"");
    strcat(command, "AiO-LAN");
    strcat(command, "\"");
    strcat(command, ",");
    strcat(command, "\"");
    strcat(command, "Hobbybrauer");
    strcat(command, "\"");
    strcat(command, ",4,3");                              //Channel 4 und WPA2_PSK
    strcat(command, "\r\n");
    Serial2.print(command);
    Serial.println(command);
    getReply( 3000 );

    Serial2.print("AT+CWSAP?\r\n");                       //wurden die Werte übernommen?
    getReply( 2000 );

    strcpy(command, "AT+CIPAP=");                         //Setzen der IP-Adresse des ESP
    strcat(command, "\"");
    strcat(command, "192.168.100.1");
    strcat(command, "\"");
    strcat(command, "\r\n");
    Serial2.print(command);
    Serial.println(command);
    getReply( 3000 );

 /*   strcpy(command, "AT+CWDHCP=2,1");                   //DHCP für SoftAP und Station
    strcat(command, "\r\n");
    Serial2.print(command);
    Serial.println(command);
    getReply( 1000 ); */

    Serial.println("IP-Adresse holen");
    Serial2.print("AT+CIFSR\r\n");
    getReply( 2000 );

    Serial2.println("AT+CIPMUX=1");                       //Multiple Connections
    getReply( 1500 );

    Serial.println("Server einrichten");
    Serial2.print("AT+CIPSERVER=1\r\n");
    getReply( 2000 );


    strcpy(command, "AT+CIPSTART=4,");
    strcat(command, "\"");
    strcat(command, "UDP");
    strcat(command, "\"");
    strcat(command, ",");
    strcat(command, "\"");
    strcat(command, "192.168.100.255");
    strcat(command, "\"");
    strcat(command, ",50000,50000,0");
    strcat(command, "\r\n");
    Serial2.print(command);
    Serial.println(command);
    getReply( 3000 );

  }

  if (modus == 242) modus = 5;
}


//-------------------------------------------------------------------------------

void getReply(int wait)
{

  int tempPos = 0;
  long int time = millis();
  while ( (time + wait) > millis())
  {
    while (Serial2.available())
    {
      char c = Serial2.read();
      if (tempPos < 500) {
        reply[tempPos] = c;
        tempPos++;
      }
    }
    reply[tempPos] = 0;
  }

  if (printReply) {
    Serial.println( reply );
    Serial.println(line);
  }

}
//-------------------------------------------------------------------------------

void wifieinaus() //Modus=243 ---------------------------------------------------
{

  if (anfang == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("WLAN:");
    lcd.setCursor(0, 1);
    lcd.print("EIN:");
    anfang = 1;
    drehen = EEPROM.read(Wlan);
  }

  char antwort = ja_nein[drehen % 2];

  lcd.setCursor(5, 1); lcd.print(antwort);

  if (ButtonPressed)
  {
    modus = 5;
    if (EEPROM.read(Wlan) != drehen % 2) EEPROM.write(Wlan, drehen % 2);
    speichern();
    anfang = 0;
    if (drehen % 2 == 1) {
      Serial.begin(115200);
      Serial2.begin(115200);
      wlanAktiv = true;
      modus = 242;
    } else Serial2.end();

  }
}




//LogView Studio -- Download unter : http://www.logview.info/forum/index.php?resources/
//hier können natürlich auch andere Protokolle hinterlegt werden!

void logger_logview() //Daten für Logview-Studio bereitstellen ------------------------
{
  if (Serial.available() > 0)
  {
    char c = Serial.read();
    switch (c)
    {
      case 83:                                   // "S" -> Start
        Serial.println("Start");
        // Send Header information
        Serial.print("$N$;Maische Temp Logging\r\n");

        Serial.print("$C$;Sollwert[C];IstTemp [C]\r\n");
        loggen = true;
        break;
      case 69:                                   // "E" -> End
        Serial.println("Log ende");
        loggen = false;
        break;
    }
  }
  if (loggen)
  {
    String data;

    data = "$";
    data += String(sollwert);
    data += ";";
    data += String(isttemp);
    data += ("\r\n");

    Serial.print(data);                //Sende Messdaten via COM

    Serial2.print("AT+CIPSEND=4,");    //Sende Messdaten via UDP

    Serial2.println(data.length() + 2);

    delay(10);
    if (Serial2.find(">")) {  //ESP8266 sendebereit
      Serial2.print(data);  //abschicken
      Serial2.print("\r\n");
      delay(10);
    }
  }
}

//-------------------------------------------------------------------------------------

//SerialComInstruments - Download unter: http://www.serialcominstruments.com/instrument4.php
//hier können natürlich auch andere Protokolle hinterlegt werden!


void logger_serial()  //Daten für SerialComInstruments4 bereitstellen
{
  String data;
  data = "#";
  data += "01";  //Kanal 1
  data += "M";
  data += String(isttemp);  //Isttemperatur
  data += "<";

  data += "#";
  data += "02";  //Kanal 2
  data += "M";
  data += String(sollwert);  //Solltemperatur
  data += "<";

  data += "#";
  data += "03"; //Kanal 3
  data += "M";
  data += String(gradient);  //Gradient
  data += "<";

  if (heizung == 1)
  {
    data += "#";
    data += "04"; //Kanal 4
    data += "M";
    data += "1";  //Heizung EIN
    data += "<";
  }
  else
  {
    data += "#";
    data += "04";  //Kanal 4
    data += "M";
    data += "0";  //Heizung AUS
    data += "<";
  }

  if (rwerk == 1)
  {
    data += "#";
    data += "05";  //Kanal 5
    data += "M";
    data += "1";  //Rührer EIN
    data += "<";
  }
  else
  {
    data += "#";
    data += "05";  //Kanal 5
    data += "M";
    data += "0";  //Ruehrer AUS
    data += "<";
  }

  Serial.println(data); //Com-Port-Datenübertragung

  Serial2.print("AT+CIPSEND=4,");    //Sende Messdaten

  Serial2.println(data.length() + 2);

  delay(10);
  if (Serial2.find(">")) {  //ESP8266 sendebereit
    Serial2.print(data);  //abschicken
    Serial2.print("\r\n");
    delay(10);
  }
}

//-------------------------------------------------------------------------------------
void signalton(int dauer)
{
  digitalWrite(RufR, B_EIN);   // Alarm einschalten
  delay(dauer);
  digitalWrite(RufR, B_AUS);   // Alarm ausschalten
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void EEPROMWritelong(int address, long value)
{
  byte four = (value & 0xFF);
  byte three = ((value >> 8) & 0xFF);
  byte two = ((value >> 16) & 0xFF);

  EEPROM.write(address, four);
  EEPROM.write(address + 1, three);
  EEPROM.write(address + 2, two);
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
long EEPROMReadlong(long address)
{
  long four = EEPROM.read(address);
  long three = EEPROM.read(address + 1);
  long two = EEPROM.read(address + 2);

  return ((four << 0) & 0xFF) + ((three << 8) & 0xFFFF) + ((two << 16) & 0xFFFFFF);
}
//-------------------------------------------------------------------------------------

//Funkcodes einlesen ------------------------------------------------------------------

void init_funk()
{
  funk_heizung_ein = EEPROMReadlong(Heizung_EIN);
  funk_heizung_aus = EEPROMReadlong(Heizung_AUS);
  funk_ruehrer_ein = EEPROMReadlong(Ruehrer_EIN);
  funk_ruehrer_aus = EEPROMReadlong(Ruehrer_AUS);
  funk_ruf_ein = EEPROMReadlong(Ruf_EIN);
  funk_ruf_aus = EEPROMReadlong(Ruf_AUS);
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void speichern()
{
  lcd.setCursor(0, 2);
  lcd.print("speichern");
  delay(500);
}
//-------------------------------------------------------------------------------------

// Funktion Abbruch--------------------------------------------------------------------
void funktion_abbruch()       // Modus 80
{
  regelung = 0;
  heizung = 0;

  if (rwerk == 1) ruehrerEinAus(0);
  rwerk = 0;
  digitalWrite(HeizungR1, H_AUS);  //Heizung aus
  digitalWrite(HeizungR2, H_AUS);
  digitalWrite(RufR, B_AUS);   // ausschalten
  digitalWrite(RuehrerR1, R_AUS);   // ausschalten
  digitalWrite(RuehrerR2, R_AUS);   // ausschalten
  mySwitch.send(funk_ruehrer_aus, 24);
  delay(100);
  digitalWrite(fuellstand_pumpe, SUDPUMPE_AUS);  //Sudpumpe ist ausgeschaltet
  mySwitch.send(funk_heizung_aus, 24);

  x = 1;                              //Rasteingaben
  h = 0;                              //Hopfeneingaben
  y = 1;
  n = 0;
  nachgussruf = false;
  loggen = EEPROM.read(logging);     //aktuellen Status von loggen setzen
  pause = 0;
  schwelle_erreicht = false;         // für Kochbeginn Meldung

  first = true;
  kzeitverz = 0;                    //Kompressorverzögerung

  zeitz = true;                     // Zeit läuft nach Doppelclick weiter wenn zeitz = false

  anfang = 0;                       //Daten zurücksetzen
  rufmodus = 0;                     //bleiben erhalten
  drehen = sollwert;                  //Zuweisung für Funktion Temperaturregelung
  sollwert = 20;

  if (EEPROM.read(notfallmodus) == 1)
  {
    EEPROM.write(notfallmodus, 0); //Notfallmodus deaktiviert
    EEPROM.write(zeit_h, 0);
    EEPROM.write(zeit_m, 0);
    EEPROM.write(zeit_s, 0);
  }



  if (altmodus == 1)
  {
    if (knot) knot = false; else knot = true;
    if (!knot) {
      if (EEPROM.read(k_aktiv) != 1) EEPROM.write(k_aktiv, 1);  //Beim Neustart in Modus 0 , bei Stromausfall in Modus (1) Kühlen
      if (EEPROM.read( g_kuehltemp) != drehen) EEPROM.write( g_kuehltemp, drehen);
      lcd.setCursor(0, 3);
      lcd.print("NOT->EIN");;
      delay(1000);
    }
    if (knot) {
      lcd.setCursor(0, 3); lcd.print("NOT->AUS"); delay(1000); //Notstart zurücksetzen
      if (EEPROM.read(k_aktiv) == 1) EEPROM.write(k_aktiv, 0);
    }  //nach Notfall- wieder Normalmodus
  }

  //  altmodus = 0;                     //Merker alter Modus
  modus = 0;                        //Hauptmenue
  lcd.clear();
}

//---------------------------------------------------------------------------------

void zum_pc()
{
  String data;
  data = String(isttemp);  //Isttemperatur
  data += ";";

  data += String(sollwert);  //Solltemperatur
  data += ";";
  data += String(gradient);  //Gradient
  data += ";";
  if (heizung == 1) data += "1"; else data += "0";
  data += ";";
  if (rwerk == 0) data += "0"; else data += "1";

  Serial.println(data); //Com-Port-Datenübertragung

  Serial2.print("AT+CIPSEND=4,");    //Sende Messdaten

  Serial2.println(data.length() + 2);

  delay(10);
  if (Serial2.find(">")) {  //ESP8266 sendebereit
    Serial2.print(data);  //abschicken
    Serial2.print("\r\n");
    delay(10);
  }
}

void zurAiO(int wait)
{
  int tpos = 0;
  int tempPos = 0;
  String data;
  long int time = millis();
  while ( (time + wait) > millis())
  {

    while (Serial2.available())
    {
      char c = Serial2.read();
      if ((tpos < 500) && (c != '\n') && (c != '\r')) {
        antwort[tpos] = c;
        tpos++;
      }

    }
    antwort[tpos] = 0;
  }

  responce = String(antwort);

  Serial.println(responce);

  if (modus == 0)
  {
    if (responce.indexOf("m27") > 0) //Starte Maischen
    {
      lcd.clear();
      modus = 27;
      anfang = 0;
      signalton(500);
      return;
    }

    if (responce.indexOf("m2") > 0) //Nachguss
    {
      lcd.clear();
      modus = 2;
      anfang = 0;
      signalton(500);
      return;
    }

    if (responce.indexOf("m41") > 0) //Kochen
    {
      lcd.clear();
      modus = 41;
      anfang = 0;
      signalton(500);
      return;
    }

    if (responce.indexOf("IPD") > 0) {
      split();
      if (!uebertragungsfehler)
      signalton(500);
    }
  }

  if (responce.indexOf("m80") > 0) //Abbruch
  {
    modus = 80;
    anfang = 0;
    signalton(500);
    return;
  }
}

void split()
{ byte n;
  char * pch;
  pch = strtok (antwort, ";:");
  n = 0;
  uebertragungsfehler = false;
  while (pch != NULL)
  {
    pch = strtok (NULL, ";");
    if (n == 0) maischtemp = atoi(pch);
    if (n == 1) rasten = atoi(pch);
    if (n == 2) kochzeit = atoi(pch);
    if (n == 3) {
      rastTemp[1] = atoi(pch);
      if (rasten == 1) endtemp = rastTemp[1];
    }
    if (n == 4) {
      rastTemp[2] = atoi(pch);
      if (rasten == 2) endtemp = rastTemp[2];
    }
    if (n == 5) {
      rastTemp[3] = atoi(pch);
      if (rasten == 3) endtemp = rastTemp[3];
    }
    if (n == 6) {
      rastTemp[4] = atoi(pch);
      if (rasten == 4) endtemp = rastTemp[4];
    }
    if (n == 7) {
      rastTemp[5] = atoi(pch);
      if (rasten == 5) endtemp = rastTemp[5];
    }

    if (n == 8) rastZeit[1] = atoi(pch);
    if (n == 9) rastZeit[2] = atoi(pch);
    if (n == 10) rastZeit[3] = atoi(pch);
    if (n == 11) rastZeit[4] = atoi(pch);
    if (n == 12) rastZeit[5] = atoi(pch);
    if (n == 13)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[0] = atoi(pch);
    if (n == 14)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[1] = atoi(pch);
    if (n == 15)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[2] = atoi(pch);
    if (n == 16)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[3] = atoi(pch);
    if (n == 17)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[4] = atoi(pch);
    if (n == 18)
        if (atoi(pch) < 0) nachisomerisierung = abs(atoi(pch)); else hopfengabe[5] = atoi(pch);
    if (n == 19) hanz = atoi(pch); 
    n++;
  }
  if (n != 21) uebertragungsfehler = true; 
  rasten--;
}

//-------------------------------------------------------------------------------------
//Ende des Programms
//-------------------------------------------------------------------------------------



